/*====================================================================

Objectweb Browser framework
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.core.panel;

import javax.swing.JPanel;

import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.api.Panel;

/**
 * This class is a basic implementation of the ViewPanel interface.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public abstract class NodeViewPanel 
    extends JPanel 
    implements Panel {

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for ViewPanel interface.
    //
    //==================================================================

    /*
     * @see org.objectweb.util.browser.api.ViewPanel#getPanel()
     */
    public JPanel getPanel() {
        return this;
    }

    /*
     * @see org.objectweb.util.browser.api.ViewPanel#preInitialize()
     */
    public void preInitialize() {
        // Nothing to do
    }

    /*
     * @see org.objectweb.util.browser.api.ViewPanel#setTreeView(org.objectweb.util.browser.gui.common.TreeView)
     */
    public abstract void setTreeView(TreeView treeView);

    /*
     * @see org.objectweb.util.browser.api.ViewPanel#postInitialize()
     */
    public void postInitialize() {
        // Nothing to do
    }

}