/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.core.popup;

/** The Java API's imports  */
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;

/** The Console's imports */
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.core.common.DynamicTree;

/**
 *  Defines the default action which wraps the ExtendedActionListener.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class DefaultAction implements ActionListener {

    protected DynamicTree tree_ = null;
    protected MenuItem delegate_ = null;

    public DefaultAction(DynamicTree tree, MenuItem actionListener) {
        tree_ = tree;
        delegate_ = actionListener;
    }

    public void actionPerformed(ActionEvent e) {
        try {
            delegate_.actionPerformed(new DefaultMenuItemTreeView(e, tree_));
        } catch (Exception e1) {
            //e1.printStackTrace();
            JOptionPane.showMessageDialog(null, e1.getClass().getName() + ":\n" + e1.getMessage(), "Exception (" + e.getActionCommand() + ")", JOptionPane.ERROR_MESSAGE);
        }
        tree_.refreshAll();
    }

}
