/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.core.popup;

/** To use the JMenuItem class */
import javax.swing.JMenuItem;

/** To use the ExtendedActionListener class */
import org.objectweb.util.browser.api.MenuItem;

/** To use the DynamicTree class */
import org.objectweb.util.browser.core.common.DynamicTree;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class MyJMenuItem extends JMenuItem {

    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    /** The associated tree */
    protected DynamicTree tree_;

    /** The name of the instance class */
    protected String className_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public MyJMenuItem(DynamicTree tree, String name) {
        super(name);
        tree_ = tree;
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Adds an ActionListener to the button.
     *
     * @param l the ActionListener to be added
     */
    public void addActionListener(MenuItem l) {
        super.addActionListener(new DefaultAction(tree_, l));
        className_ = l.getClass().getName();
    }

    /**
     * Returns the name of the instance class
     */
    public String getActionClassName() {
        return className_;
    }
}
