/*====================================================================

Objectweb Browser framework
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.plugins.java;

import java.util.Properties;

import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;

/**
 * This class allows to remove a property from a <code>java.util.Properties<code> object.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class RemovePropertyAction 
    implements MenuItem {

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public method for MenuItem interface.
    //
    //==================================================================

	/**
	 * @see org.objectweb.util.browser.api.MenuItem#getStatus(org.objectweb.util.browser.api.TreeView)
	 */
	public int getStatus(TreeView treeView) {
        // Enabled item
        return MenuItem.ENABLED_STATUS; 
	}

	/**
	 * @see org.objectweb.util.browser.api.MenuItem#actionPerformed(org.objectweb.util.browser.api.MenuItemTreeView)
	 */
	public void actionPerformed(MenuItemTreeView treeView) throws Exception {
        // Obtaining the name of the entry
        Entry entry = treeView.getSelectedEntry();
        String value = (String)entry.getName();
        // Obtaining the Java Properties
        Properties properties = (Properties)treeView.getParentObject();
        // Removing the property
        properties.remove(value);
	}

}