/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2002-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s): .

====================================================================*/

package org.objectweb.openccm.services.trading;

import org.omg.CosTrading.LookupPackage.SpecifiedProps;

/**
 * Wrapper class in order to manipulate the
 * CosTrading::Lookup::SpecifiedProps union independently of the used
 * ORB product.
 *
 *  @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain.Leblanc</a>
 *
 *  @version 0.1
 */
public class SpecifiedPropsWrapper {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     *  The default constructor.
     */
    public SpecifiedPropsWrapper() {}

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public static methods.
    //
    // ==================================================================

    /**
     * Creates a CosTrading::Lookup::SpecifiedProps union with
     * discriminator initialized with the HowManyProps.none value.
     *
     * @return An CosTrading::Lookup::SpecifiedProps union
     * object.
     */
    public static org.omg.CosTrading.LookupPackage.SpecifiedProps
    create_none() {
        SpecifiedProps sp = new SpecifiedProps();
        sp.__default();
        return sp;        
    }

    /**
     * Creates a CosTrading::Lookup::SpecifiedProps union with
     * discriminator initialized with the HowManyProps.all value.
     *
     * @return An CosTrading::Lookup::SpecifiedProps union
     * object.
     */
    public static org.omg.CosTrading.LookupPackage.SpecifiedProps
    create_all() {
        SpecifiedProps sp = new SpecifiedProps();
        sp.__default(org.omg.CosTrading.LookupPackage.HowManyProps.all);
        return sp;
        
    }

    /**
     * Creates a CosTrading::Lookup::SpecifiedProps union with
     * discriminator initialized with the HowManyProps.some value.
     *
     * @param property_names The names of the required properties to
     * specify in the SpecifiedProps union.
     *
     * @return An CosTrading::Lookup::SpecifiedProps union
     * object.
     */
    public static org.omg.CosTrading.LookupPackage.SpecifiedProps
    create_some(String[] property_names) {
        SpecifiedProps sp = new SpecifiedProps();
        sp.prop_names(property_names);
        return sp;
    }
}
