/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.descriptor.componentassembly.ccm;

import org.objectweb.ccm.descriptor.componentassembly.beans.*;
import org.objectweb.ccm.descriptor.componentassembly.*;

public class ComponentfilesDeployer{
    
    /**
     * DeployPartial methods simply call on each componentfile children the deployPartial
     * methods. Here the extension manager is use to call directly the deployPartial method
     * an the linked componentfileDeployer object.
     */
    public void deployPartial(java.util.Hashtable deployTable,Componentfiles cfi)
    {
    /* Open an iterator to browse all the componentfile children*/
    for(java.util.Iterator i=cfi.getComponentfileList().iterator();i.hasNext(); ){
        ComponentfileBean current=(ComponentfileBean)i.next();
        ((ComponentfileDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deployPartial(deployTable,current);
    }
    }

    /**
     * DeployFinal have exactly the same behavior than deployPartial but call deployFinal
     * function.
     */
    public void deployFinal(java.util.Hashtable deployTable,Componentfiles cfi)
    {
    for(java.util.Iterator i=cfi.getComponentfileList().iterator();i.hasNext(); ){
        ComponentfileBean current=(ComponentfileBean)i.next();
        ((ComponentfileDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).deployFinal(deployTable,current);
    }
    }

    /**
     * Browse each children to invoke on them the tearDownConnection method. Extension manager
     * is use too.
     */
    public void tearDownConnections(java.util.Hashtable deployTable,Componentfiles cfi)
    {
    for(java.util.Iterator i=cfi.getComponentfileList().iterator();i.hasNext(); ){
        ComponentfileBean current=(ComponentfileBean)i.next();
        ((ComponentfileDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDownConnections(deployTable,current);
    }
    }

    /**
     * Browse each children to invoke on them the tearDownInstance method. Extension manager
     * is use too.
     */
    public void tearDownInstantiations(java.util.Hashtable deployTable,Componentfiles cfi)
    {
    for(java.util.Iterator i=cfi.getComponentfileList().iterator();i.hasNext(); ){
        ComponentfileBean current=(ComponentfileBean)i.next();
        ((ComponentfileDeployer)
         current
         .getExtensionManager().getExtensionByName("ccm.Deployer")
         .getInstance()).tearDownInstantiations(deployTable,current);
    }
    }
}
