/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.descriptor.componentassembly.ccm;
//Import all required packages
import org.objectweb.ccm.descriptor.componentassembly.beans.*;
import org.objectweb.ccm.descriptor.componentassembly.*;

/**
 * Process the processcollocation deployment.
 *
 * @author <a href="mailto:frederic.briclet@lifl.fr">Briclet Frederic</a>
 *
 * @version 0.1
 */
public class ProcesscollocationDeployer{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================


    /**
     * Deploy method browse all its homeplacement children an call their 
     * deploy method thows extension manager.
     * @param deployTable the internal table use to store information.
     * @param pci the processcollocation to browse
     **/
    public void 
    deploy(java.util.Hashtable deployTable,
           Processcollocation pci )
    {
        for( java.util.Iterator i= pci.getHomeplacementList().iterator(); i.hasNext();){
            HomeplacementBean current=(HomeplacementBean)i.next();
            ((HomeplacementDeployer)current
             .getExtensionManager().getExtensionByName("ccm.Deployer")
             .getInstance()).deploy(deployTable,pci.getDestination(),current);
        }
    }
    
    /**
     * TearDown method browse all its homeplacement children an call their 
     * tearDown method thows extension manager.
     * @param deployTable the internal table use to store information.
     * @param pci the processcollocation to browse
     **/     
    public void 
    tearDown(java.util.Hashtable deployTable,
             Processcollocation pci )
    {
    
        for( java.util.Iterator i= pci.getHomeplacementList().iterator(); i.hasNext();){
            HomeplacementBean current=(HomeplacementBean)i.next();
            ((HomeplacementDeployer)current
             .getExtensionManager().getExtensionByName("ccm.Deployer")
             .getInstance()).tearDown(deployTable,pci.getDestination(),current);
        }
    }
    
}
