/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the implementation of the OpenCCM_DCI::ComponentServerManager
 * component type.
 *
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class ComponentServerManagerImpl
     extends org.objectweb.openccm.OpenCCM_DCI
             .ComponentServerManagerSessionComposition
             .ComponentServerManagerImpl
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    //Configvalues used to configure the Componentserver facet
    private org.omg.Components.ConfigValue configuration[];    
    //private cookie identifiing parent node connection
    private org.omg.Components.Cookie cookie;
    //The component server manager registration interface
    private org.objectweb.openccm.OpenCCM_DCI
        .ComponentServerManagerRegistration CSMR;    
    //temporary boolean to marks the ComponentsServer removall will be replace
    // by design pattern state
    private boolean removed;

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    public void 
    configuration_complete()
    {
        //retrieve the ComponentServerManagerRegistration interface
        CSMR=get_context()
            .get_connection_component_server_manager_registration();
        
        try{
            org.omg.Components.SessionContext sc=
                (org.omg.Components.SessionContext)get_context();
           
            ((ComponentServerSegImpl)obtain_executor("component_server"))
                .configuration(configuration);
            
            cookie= CSMR.register_component_server_manager
                (org.objectweb.openccm.
                 OpenCCM_DCI.ComponentServerManagerHelper
                 .narrow(sc.get_CCM_object()));
           
            ((ComponentServerSegImpl)
             obtain_executor("component_server")).cookie(cookie);          
                       
   
        }
        catch(Exception e)
            {
                e.printStackTrace();
            }
    }
    

    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        if(!removed){
            removed=true;
            try{
                //CSMR.unregister_component_server_manager(cookie);  
                ((ComponentServerSegImpl)
                 obtain_executor("component_server")).remove();
                }
            catch(Exception e )
                {
                    System.out.println("Deconnection ComponentServer/Node impossible");
                    e.printStackTrace();
                }           
        }              
    }

    
    
    // ==================================================================
    //
    // Accessor methods.
    //
    // ==================================================================
    public 
    org.omg.Components.ConfigValue []
    config()
    {
        return configuration;
    }

    public 
    void 
    config(org.omg.Components.ConfigValue configuration[]){
        this.configuration=configuration;
    }
    
}
