/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.CosTrading.gui;

/** The Java Swing imports. */
import javax.swing.Box;

/** The administration console's API imports */
import org.objectweb.openccm.browser.menu.FileChooserBox;
import org.objectweb.openccm.browser.menu.OpenCCMBrowserConstants;

/** 
 * Internal Panel class to use in order to browse files for TSTD.     
 */
public class AddServiceTypesPanel extends javax.swing.JPanel {
        
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The file chooser. */
    protected FileChooserBox fcb_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /** 
     * Default constructor. 
     */ 
    public AddServiceTypesPanel() {
        Box b = Box.createVerticalBox();
        b.add(Box.createVerticalGlue());
            
        fcb_ = new FileChooserBox("Trading Service Type Description file: ", OpenCCMBrowserConstants.XML_FILE_CHOOSER);
        b.add(fcb_);

        b.add(Box.createVerticalGlue());
            
        add(b);
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Returns the TSTD file name.
     *
     * @return The choosen file name.
     */
    public String getFileName() {
        if (fcb_.getFile() == null) return null;
        return fcb_.getFile().getAbsolutePath();
    }

}


