@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Jrme Moroy
rem # Contributor(s): Sylvain Leblanc, Philippe Merle.
rem #
rem # ====================================================================
rem #
rem # Starting an OpenCCM Browser Console.
rem #
rem # ====================================================================

rem # the argument
set args=""

rem #  ============================
rem #  OpenCCM Platform installed ?
rem #  ============================

:platform_installed
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

echo The OpenCCM Browser will be started.

rem # ================================================
rem # Obtain the IOR of the started CosNaming Service.
rem # ================================================

if not exist %OpenCCM_CONFIG_DIR%\NameService.IOR goto :ir
for /f %%i in (%OpenCCM_CONFIG_DIR%\NameService.IOR) do set IOR_NS=%%i
set args=-ORBInitRef NameService=%IOR_NS%

rem # ===================================================
rem # Obtain the IOR of the started Interface Repository.
rem # ===================================================

:ir

if not exist %OpenCCM_CONFIG_DIR%\IR3.IOR goto :trader
for /f %%i in (%OpenCCM_CONFIG_DIR%\IR3.IOR) do set IOR_IR=%%i
set args=%args% -ORBInitRef InterfaceRepository=%IOR_IR%

rem # =================================================
rem # Obtain the IOR of the started CosTrading Service.
rem # =================================================

:trader

if not exist %OpenCCM_CONFIG_DIR%\TradingService.IOR goto :launch
call trader_ior > %OpenCCM_CONFIG_DIR%\trader.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\trader.tmp) do set ior_Trader=%%i
del %OpenCCM_CONFIG_DIR%\trader.tmp

set args=%args% -ORBInitRef TradingService=%ior_Trader%

rem #  ==================================
rem #  Start the OpenCCM Browser Console.
rem #  ==================================

:launch

rem # Execute the OpenCCM Browser console.
rem #
call launcher exec "" "%* %args% %OpenCCM_HOMEDIR%\xml\launcher\Browser.xml"
