@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Briclet Frederic
rem # Contributor(s): ----------------
rem #
rem # ====================================================================
rem #
rem #  Starting a OpenCCM DCIManager.
rem #
rem # ====================================================================

setlocal

rem #  =====================
rem #  Compute Command Line
rem #  =====================

set /a nb_args=0
for %%i in (%*) do set /a nb_args=nb_args+1

if %nb_args% == 0 goto help
rem # if %nb_args% > 1 goto help

if "%1"=="-h" goto :help
if "%1"=="?" goto :help


:set_name
set dci_name=%1
set dci_path=%OpenCCM_CONFIG_DIR%\DCIManagers\%dci_name\dci_%dci_name%
goto :start

:help
echo "usage: dci_start  <dci_name>"	
goto :eof

:start

set run_id=dci_start

rem #  ============================
rem #  OpenCCM Platform installed ?
rem #  ============================

:platform_installed
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

rem #  ======================
rem #  Name Service started ?
rem #  ======================

rem # Obtain the IOR of the started Name Service.
call ns_ior > %OpenCCM_CONFIG_DIR%\DCIManagers\%dci_name%.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\DCIManagers\%dci_name%.tmp) do set ior_NS=%%i
del %OpenCCM_CONFIG_DIR%\DCIManagers\%dci_name%.tmp

rem # Check if a Name Service is started.
if defined ior_NS goto test_dci

echo Error: The Name Service is not started!
goto :eof

:test_dci

rem #  =============
rem #  DCI started ?
rem #  =============

rem # Check if this Java Component Server is already started.
if not exist %dci_path%.PID goto :dci_not_started

echo Error: The Component DCIManager %dci_name%  is already started!
goto :eof

:dci_not_started

mkdir %OpenCCM_CONFIG_DIR%\DCIManagers\%dci_name%

set jvm_args="-Dior_ns=%ior_NS%"

set dci_path=%OpenCCM_CONFIG_DIR%\DCIManagers\%dci_name%\dci_%dci_name%

set args="--runid %run_id% NSREGISTER=OpenCCM/DCIManagers/%dci_name% DCINAME=%dci_name% IORPATH=%dci_path%.IOR %OpenCCM_HOMEDIR%\xml\launcher\dci_server.xml"

call launcher fork %jvm_args% %args%  %dci_path%.output %dci_path%.PID

rem # Wait for the IR3.IOR file produced.
:wait
set READY=
if not exist %dci_path%.IOR goto :wait

call set_default_dci_manager %dci_path%.IOR
echo The DCIManager %dci_name% is started
