@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Philippe Merle.
rem # Contributor(s): .
rem #
rem # ====================================================================
rem #
rem # Starting the OpenCCM Interface Repository and
rem # feeding it all OpenCCM OMG IDL files.
rem #
rem # ====================================================================

setlocal

rem # ====================================================================
rem # Starts the OpenCCM Interface Repository.
rem #
rem # %OpenCCM_HOMEDIR}\idl\CORBA.idl
rem # %OpenCCM_HOMEDIR}\idl\IFR_3_0.idl
rem # %OpenCCM_HOMEDIR}\idl\Components.idl 
rem # are fed automatically.

call ir3_start

rem # ====================================================================
rem # Feeds the CosNaming module.
rem #
rem # Don't require to feed other files previously.
rem #

call ir3_feed %OpenCCM_HOMEDIR%\idl\CosNaming.idl

rem # ====================================================================
rem # Feeds the CosTrading module.
rem #
rem # Don't require to feed other files previously.
rem #

call ir3_feed %OpenCCM_HOMEDIR%\idl\CosTrading.idl

rem # ====================================================================
rem # Feeds the CosTradingDynamic module.
rem #
rem # Require to feed CosTrading.idl previously.
rem #

call ir3_feed %OpenCCM_HOMEDIR%\idl\CosTradingDynamic.idl

rem # ====================================================================
rem # Feeds the CosTradingRepos module.
rem #
rem # Require to feed CosTrading.idl previously.
rem #

call ir3_feed %OpenCCM_HOMEDIR%\idl\CosTradingRepos.idl

rem # ====================================================================
rem # Feeds the CosTransactions module.
rem #
rem # Don't require to feed other files previously.
rem #

call ir3_feed %OpenCCM_HOMEDIR%\idl\CosTransactions.idl

rem # ====================================================================
rem # Feeds the CosPersistentState module.
rem #
rem # Require to feed CosTransactions.idl previously.
rem #

call ir3_feed %OpenCCM_HOMEDIR%\idl\CosPersistentState.idl

rem # ====================================================================
rem # Feeds OpenCCM specific API.
rem #

rem # Don't require to feed other files previously.
rem #
call ir3_feed %OpenCCM_HOMEDIR%\idl\ow_corba_ast_api.idl

rem # Require to feed ow_corba_ast_api.idl previously.
rem #
call ir3_feed %OpenCCM_HOMEDIR%\idl\ow_corba_parser_api.idl

rem # Don't require to feed other files previously.
rem #
call ir3_feed %OpenCCM_HOMEDIR%\idl\ow_openccm_api.idl

rem # Require to feed ow_openccm_api.idl previously.
rem #
call ir3_feed %OpenCCM_HOMEDIR%\idl\ow_openccm_components_api.idl

rem # Don't require to feed other files previously.
rem #
call ir3_feed %OpenCCM_HOMEDIR%\idl\ow_openccm_containers_api.idl

rem # Require to feed ow_openccm_api.idl previously.
rem #
call ir3_feed %OpenCCM_HOMEDIR%\idl\ow_openccm_deployment_api.idl

rem # Require to feed CosTransactions.idl and
rem # ow_openccm_deployment_api.idl previously.
rem #
call ir3_feed %OpenCCM_HOMEDIR%\idl\ow_openccm_plugins_transaction_api.idl

rem # ====================================================================
rem # Feed the IST COACH Tracing Service.
rem #
rem # Don't require to feed other files previously.

call ir3_feed %OpenCCM_HOMEDIR%\idl\coach_tracing.idl

rem # ====================================================================
rem # Feed the IST COACH Distributed Computing Infrastructure (DCI).
rem #
rem # Require previously to feed
rem # CORBA.idl
rem # Components.idl
rem # CosNaming.idl
rem # CosTrading.idl

call ir3_feed %OpenCCM_HOMEDIR%\idl\DCI.idl3

rem # ====================================================================
rem # Feed the OpenCCM DCI.
rem #
rem # Require to feed Components.idl and DCI.idl3 previously.

call ir3_feed %OpenCCM_HOMEDIR%\idl\OpenCCM.idl3
