@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Philippe Merle.
rem # Contributor(s): .
rem #
rem # ====================================================================

@setlocal

rem # ====================================================================
rem # Ant compilation if needed.
rem # ====================================================================

if not exist generated\idl\simple.idl ( call build.bat )
if not exist archives\simple.jar ( call build.bat )

rem # ====================================================================
rem # Install the OpenCCM Platform.
rem # ====================================================================

call ccm_install

rem # ====================================================================
rem # Start the Name Service.
rem # ====================================================================

call ns_start

rem # Obtain the IOR of the started Name Service.
call ns_ior > %OpenCCM_CONFIG_DIR%\ccm_deploy.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\cm_deploy.tmp) do set ior_NS=%%i
del %OpenCCM_CONFIG_DIR%\ccm_deploy.tmp

rem # ====================================================================
rem # Start the Java Component Server.
rem # ====================================================================

call jcs_start ComponentServer 

rem # ====================================================================
rem # Install the demonstration.
rem # ====================================================================

echo Starting simple home installation...
set jvm_args=-Dior_ns=%ior_NS%

launcher exec "%jvm_args%" "simple.xml"

rem # ====================================================================
rem # Stop the Java Component Server.
rem # ====================================================================

call jcs_stop ComponentServer

rem # ====================================================================
rem # Stop the Name Service.
rem # ====================================================================

call ns_stop

rem # ====================================================================
rem # Deinstall the OpenCCM Platform.
rem # ====================================================================

call ccm_deinstall
