/*====================================================================

ObjectWeb Util Launcher Package.
Copyright (C) 2003 INRIA & USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Christophe Demarey.
Contributor(s): Romain Rouvoy.

====================================================================*/

package org.objectweb.util.launcher;


import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;


public class CommandJavaTest
    extends TestSuite
{
    protected class CommandJavaTestCase
        extends TestCase
    {
        /** the CommandJava invariant */
        protected CommandJava invariant_ ;
        /** the CommandJava fixture */
        protected CommandJava fixture_ ;
        
        /** 
         * Dynamic call constructor 
         *
         * @param method - the Test Cas method to call
         */
        public CommandJavaTestCase(String method) { super(method); }

        /**
         * The fixture intialisation method
         */
        protected void setUp() {
            this.invariant_ = new CommandJava() ;
            this.invariant_.setLoader(new XBootClassLoader());
            this.fixture_ = new CommandJava() ;
            this.fixture_.setLoader(new XBootClassLoader());
        }

        /**
         * The fixture cleaning method
         */
        protected void tearDown() {
            this.invariant_ = null ;
            this.fixture_ = null ;
        }        


        public void test() {
            assertEquals("Initial comparison:",
                         invariant_,
                         fixture_);
        }
    }


    public CommandJavaTest()
    {
        addTest(new CommandJavaTestCase("test"));
    }

    public static Test suite()
    {
        return new CommandJavaTest();
    }
}
