/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */
package fr.lip6.src.modfact.generation.dtd;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;

import fr.lip6.src.modfact.io.Import;

import java.io.*;
import java.util.logging.ConsoleHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
public class Client {

	static org.omg.mof.Model.ModelPackageFactory _reference;
	public static void main(String args[]) {
		try {
			// create and initialize the ORB
			System.out.println();
			System.out.println(java.util.Calendar.getInstance().getTime());
			ORB orb = ORB.init(args, null);

			// get the root naming context
			org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
			// Use NamingContextExt instead of NamingContext. This is 
			// part of the Interoperable naming Service.  
			NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);

			// resolve the Object Reference in Naming
			String name = "Hello";
			_reference =
				org.omg.mof.Model.ModelPackageFactoryHelper.narrow(ncRef.resolve_str(name));

			//creation du Package
			org.omg.mof.Model.ModelPackage _model_package =
				_reference.create_model_package();
			Import imp = new Import();
			imp.initiate(_model_package, orb);

			org.omg.mof.Model.Package _package =
				imp.parse("C:\\SALIM\\execution\\source\\mof_1_0.xml");
			System.out.println("le package :" + _package.name() + " est cree");

			//Set the log
			System.out.println("Log !!!");
			Logger logger = Logger.getLogger("fr.lip6.src.mdafactory.generation.dtd.GenerationXMIDTD1_1");
			ConsoleHandler ch = new ConsoleHandler();
			ch.setLevel(Level.CONFIG);
			logger.addHandler(ch);
			System.out.println(
				java.util.Calendar.getInstance().getTime() + "  Avant la generation de la DTD");
			//GenerationIDL1.setModelPackage(_mof_package);
			//GenerationIDL1.setout("d:\\mof12.IDL");
			//GenerationIDL1.settrace("trace.txt");
			//GenerationIDL1.StartGeneration (_package);
			GenerationXMIDTD1_1 generator = new GenerationXMIDTD1_1();
			generator.setOut(".\\mof1.dtd");
			//GenerationXMIDTD1_1.packageContents(_package);
			generator.generateDTD(_package);
			System.out.println(
				java.util.Calendar.getInstance().getTime() + "  Apres la generation de la DTD");
		} catch (Exception e) {
			System.out.println("ERROR : " + e);
			e.printStackTrace(System.out);
		}
	}

}