/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;

import fr.lip6.src.modfact.io.Import;

import java.io.*;
public class Client {

	static org.omg.mof.Model.ModelPackageFactory _reference;
	public static void main(String args[]) {
		try {
			org.omg.mof.Model.Package _package = null;

			// create and initialize the ORB
			System.out.println();
			System.out.println(java.util.Calendar.getInstance().getTime());
			ORB orb = ORB.init(args, null);

			// get the root naming context
			org.omg.CORBA.Object objRef =
				orb.resolve_initial_references("NameService");
			// Use NamingContextExt instead of NamingContext. This is 
			// part of the Interoperable naming Service.  
			NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);
			// resolve the Object Reference in Naming
			String name = "org.omg.mof.Model.Server";
			_reference =
				org.omg.mof.Model.ModelPackageFactoryHelper.narrow(
					ncRef.resolve_str(name));

			//creation du Package
			org.omg.mof.Model.ModelPackage _model_package =
				_reference.create_model_package();
			Import imp = new Import();
			imp.initiate(_model_package, orb);

			//input XML model
			if (getInput(args) == null) {
				System.out.println("You must set the input file; use : -input");
				return;
			} else {
				_package = imp.parse(getInput(args));
				System.out.println(
					"le package :" + _package.name() + " est cree");
			}

			System.out.println(
				java.util.Calendar.getInstance().getTime()
					+ "  Avant la generation de l'IDL");
			GenerationMOFIDL1_3 generator = new GenerationMOFIDL1_3();
			if (getOutput(args) == null) {
				System.out.println(
					"You must set the output file; use : -output");
				return;
			} else
				generator.setOut(getOutput(args));

			//GenerationMOFIDL1_3.settrace("trace.txt");
			generator.generateIDL(_package);
			//GenerationDTD.setout(".\\mof1.dtd");
			//GenerationDTD.PackageContents(_package);
			//GenerationDTD.DTD(_package);
			System.out.println(
				java.util.Calendar.getInstance().getTime()
					+ "  Apres la generation de l'IDL");
		} catch (Exception e) {
			System.out.println("ERROR : " + e);
			e.printStackTrace(System.out);
		}
	}

	public static String getInput(String[] args) {
		return getParameter(args, "-input");
	}

	public static String getOutput(String[] args) {
		return getParameter(args, "-output");
	}

	public static String getTrace(String[] args) {
		return getParameter(args, "-trace");
	}

	public static String getParameter(String[] args, String param) {
		for (int i = 0; i < args.length; i++) {
			if (param.compareTo(args[i]) == 0)
				return args[i + 1];
		}
		return null;
	}

}