/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl2javaImpl;

import fr.lip6.src.modfact.util.Helper;
import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

public class AssociationImplementation {
	//Templates
	Templates templates;
	
	//Helper
	Helper helper;
	
	//Log facility
	 Logger logger = Logger.getLogger("fr.lip6.src.mdafactory.generation.idl2javaImpl.AssociationImplementation");	

	private  java.io.PrintWriter _out;

	public  void setOutput(java.io.PrintWriter _output) {
		logger.log(Level.CONFIG, "Association Implementation output set to" + _output);
		_out = _output;
	}
	public  void setOut(String _file)
		throws java.io.FileNotFoundException {
			logger.log(Level.CONFIG, "Association Implementation output set to " + _file);
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void setOut(java.io.File _file)
		throws java.io.FileNotFoundException, java.io.IOException {
						logger.log(Level.CONFIG, "Association Implementation output set to " + _file);
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void closeFile() {
					logger.log(Level.FINE, "Association Implementation closeFile");
		_out.close();
	}
	public  void generateJava(
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "Association Implementation startGeneration");
		_out.println(
			"// le Code gnr de l'association: " + _association.name());
		associationImpl(_association);
		closeFile();
	}

	public  void associationImpl(
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError {

		//les formats du nom de l'association
		String _nformat1 = helper.format1Idl2JavaConflict(_association.name());
		String _aformat1 = helper.javaQualifiedName(_association);
		String _aformat2 = helper.format2(_association.name());

		//Dcalration du Package
		_out.print("package ");

		// Affichage du nom du package
		_out.println(helper.javaPackage(_association.container()) + " ;");

		_out.println(
			"public class "
				+ _nformat1
				+ "Impl extends "
				+ _aformat1
				+ "POA {");
		_out.println(
			"\t\t"
				+ helper.format1Idl2JavaConflict(_association.container().name()+"Package")
				+ " _model_package;");

		//Affichage de RefBaseObject et RefAssociation
		_out.print(templates.refBaseObjectTemplate());
		_out.println();
		_out.print(templates.refAssociationTemplate());

		//Code propre  l'association
		org.omg.mof.Model.AssociationEnd[] _ends =
			helper.associationEnds(_association);
		org.omg.mof.Model.AssociationEnd _source = _ends[0];
		org.omg.mof.Model.AssociationEnd _dest = _ends[1];

		//Associationd_end1
		String _sourceformat1 = helper.javaQualifiedName(_source.type());
		String _sourceformat2 = helper.format2(_source.name());
		boolean _source_navig = _source.is_navigable();
		boolean _source_chang = _source.is_changeable();
		org.omg.mof.Model.MultiplicityType _msource = _source.multiplicity();
		boolean _source_ordered = _msource.isOrdered;
		boolean _source_unique = _msource.isUnique;
		int _source_upper = _msource.upper;
		//int _source_lower = _msource.lower ;

		//Association_end2
		String _destformat1 = helper.javaQualifiedName(_dest.type());
		String _destformat2 = helper.format2(_dest.name());
		boolean _dest_navig = _dest.is_navigable();
		boolean _dest_chang = _dest.is_changeable();
		org.omg.mof.Model.MultiplicityType _mdest = _dest.multiplicity();
		boolean _dest_ordered = _mdest.isOrdered;
		boolean _dest_unique = _mdest.isUnique;
		int _dest_upper = _mdest.upper;
		//int _dest_lower = _mdest.lower ;

		_out.println(
			"\t\tprivate java.util.Vector _all_"
				+ _aformat2
				+ " = new java.util.Vector();");

		_out.println("\t\t// Operation all_is_of_type_links");
		_out.println(
			"\tpublic "
				+ _aformat1
				+ "Link[] all_"
				+ _aformat2
				+ "_Links() throws org.omg.mof.Reflective.MofError {");
		_out.println(
			"\t\t"
				+ _aformat1
				+ "Link[] temp1 = new "
				+ _aformat1
				+ "Link [_all_"
				+ _aformat2
				+ ".size()];");
		_out.println(
			"\t\tfor (int i=0; i< _all_"
				+ _aformat2
				+ ".size();i++) temp1[i]= ("
				+ _aformat1
				+ "Link)_all_"
				+ _aformat2
				+ ".elementAt(i);");
		_out.println("\t\treturn temp1;");
		_out.println("\t\t }");

		_out.println("\t\t//Operation exists");
		_out.println(
			"\tpublic boolean exists("
				+ _sourceformat1
				+ " "
				+ _sourceformat2
				+ ", "
				+ _destformat1
				+ " "
				+ _destformat2
				+ ") throws org.omg.mof.Reflective.MofError {");
		_out.println("\t\tboolean exist = false;");
		_out.println("\t\tint i= 0;");
		_out.println("\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
		_out.println(
			"\t\t\t"
				+ _aformat1
				+ "Link temp1 = ("
				+ _aformat1
				+ "Link)_all_"
				+ _aformat2
				+ ".elementAt(i);");
		_out.println(
			"\t\t\tif (temp1."
				+ _sourceformat2
				+ "._is_equivalent("
				+ _sourceformat2
				+ ") && temp1."
				+ _destformat2
				+ "._is_equivalent("
				+ _destformat2
				+ ")) exist = true;");
		_out.println("\t\t\ti++;");
		_out.println("\t\t}");
		_out.println("\t\treturn exist ;");
		_out.println("\t\t} ");

		if (_source_navig) {
			_out.println("\t\t// Operation " + _sourceformat2);
			_out.print("\tpublic " + _sourceformat1);
			if ((_source_upper > 1) || (_source_upper == -1)) {
				_out.println(
					"[] "
						+ _sourceformat2
						+ " ("
						+ _destformat1
						+ " "
						+ _destformat2
						+ ") throws org.omg.mof.Reflective.MofError {");
				_out.println(
					"\t\tjava.util.Vector temp1 = new java.util.Vector();");
				_out.println(
					"\t\tfor (int i=0; i< _all_"
						+ _aformat2
						+ ".size(); i++){");
				_out.println(
					"\t\t\t"
						+ _aformat1
						+ "Link temp2 = ("
						+ _aformat1
						+ "Link)_all_"
						+ _aformat2
						+ ".elementAt(i);");
				_out.println(
					"\t\t\tif (temp2."
						+ _destformat2
						+ "._is_equivalent("
						+ _destformat2
						+ ")) temp1.addElement(temp2."
						+ _sourceformat2
						+ ");");
				_out.println("\t\t}");
				_out.println(
					"\t\t"
						+ _sourceformat1
						+ "[] temp3 = new "
						+ _sourceformat1
						+ "[temp1.size()];");
				_out.println(
					"\t\tfor (int i=0; i< temp1.size();i++) temp3[i]= ("
						+ _sourceformat1
						+ ")temp1.elementAt(i);");
				_out.println("\t\treturn temp3;");
				_out.println("\t\t}");
			} else {
				_out.println(
					" "
						+ _sourceformat2
						+ "("
						+ _destformat1
						+ " "
						+ _destformat2
						+ ") throws org.omg.mof.Reflective.MofError {");
				_out.println("\t\tboolean exist = false;");
				_out.println("\t\tint i= 0;");
				_out.println("\t\t" + _aformat1 + "Link temp1 = null;");
				_out.println(
					"\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
				_out.println(
					"\t\t\ttemp1= ("
						+ _aformat1
						+ "Link)_all_"
						+ _aformat2
						+ ".elementAt(i);");
				_out.println(
					"\t\t\tif (temp1."
						+ _destformat2
						+ "._is_equivalent("
						+ _destformat2
						+ ")) exist = true;");
				_out.println("\t\t\ti++;");
				_out.println("\t\t}");
				_out.println("\t\treturn temp1." + _sourceformat2 + ";");
				_out.println("\t\t}");
			}
		}

		if (_dest_navig) {
			_out.println("\t\t// Operation " + _destformat2);
			_out.print("\tpublic " + _destformat1);
			if ((_dest_upper > 1) || (_dest_upper == -1)) {
				_out.println(
					"[] "
						+ _destformat2
						+ "("
						+ _sourceformat1
						+ " "
						+ _sourceformat2
						+ ") throws org.omg.mof.Reflective.MofError {");
				_out.println(
					"\t\tjava.util.Vector temp1 = new java.util.Vector();");
				_out.println(
					"\t\tfor (int i=0; i< _all_"
						+ _aformat2
						+ ".size(); i++){");
				_out.println(
					"\t\t\t"
						+ _aformat1
						+ "Link temp2= ("
						+ _aformat1
						+ "Link)_all_"
						+ _aformat2
						+ ".elementAt(i);");
				_out.println(
					"\t\t\tif (temp2."
						+ _sourceformat2
						+ "._is_equivalent("
						+ _sourceformat2
						+ ")) temp1.addElement(temp2."
						+ _sourceformat2
						+ ");");
				_out.println("\t\t}");
				_out.println(
					"\t\t"
						+ _destformat1
						+ "[] temp3 = new "
						+ _destformat1
						+ "[temp1.size()];");
				_out.println(
					"\t\tfor (int i=0; i< temp1.size();i++) temp3[i]= ("
						+ _destformat1
						+ ")temp1.elementAt(i);");
				_out.println("\t\treturn temp3;");
				_out.println("\t\t}");
			} else {
				_out.println(
					" "
						+ _destformat2
						+ "("
						+ _sourceformat1
						+ " "
						+ _sourceformat2
						+ ") throws org.omg.mof.Reflective.MofError {");
				_out.println("\t\tboolean exist = false;");
				_out.println("\t\tint i= 0;");
				_out.println("\t\t" + _aformat1 + "Link temp1 = null;");
				_out.println(
					"\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
				_out.println(
					"\t\t\ttemp1= ("
						+ _aformat1
						+ "Link)_all_"
						+ _aformat2
						+ ".elementAt(i);");
				_out.println(
					"\t\t\tif (temp1."
						+ _sourceformat2
						+ "._is_equivalent("
						+ _sourceformat2
						+ ")) exist = true;");
				_out.println("\t\t\ti++;");
				_out.println("\t\t}");
				_out.println("\t\treturn temp1." + _destformat2 + ";");
				_out.println("\t\t}");
			}

		}

		if (_source_chang && _dest_chang) {
			_out.println("\t\t// Operation add");
			_out.println(
				"\tpublic void add("
					+ _sourceformat1
					+ " "
					+ _sourceformat2
					+ ", "
					+ _destformat1
					+ " "
					+ _destformat2
					+ ") throws org.omg.mof.Reflective.MofError {");
			_out.println(
				"\t\t"
					+ _aformat1
					+ "Link temp = new "
					+ _aformat1
					+ "Link("
					+ _sourceformat2
					+ ", "
					+ _destformat2
					+ ");");
			_out.println("\t\t_all_" + _aformat2 + ".addElement(temp);");
			_out.println("\t\t}");
		}

		if (_source_chang
			&& _source_navig
			&& _dest_chang
			&& ((_source_upper > 1) || (_source_upper == -1))
			&& _source_ordered) {
			_out.println("\t\t// Operation add_before" + _sourceformat2);
			_out.println(
				"\tpublic void add_before_"
					+ _sourceformat2
					+ "("
					+ _sourceformat1
					+ "  "
					+ _sourceformat2
					+ ",  "
					+ _destformat1
					+ "  "
					+ _destformat2
					+ ", "
					+ _sourceformat1
					+ " before) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ ");
			_out.println("\t\tboolean exist = false;");
			_out.println("\t\tint i= 0;");
			_out.println(
				"\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
			_out.println(
				"\t\t\t"
					+ _aformat1
					+ "Link temp1= ("
					+ _aformat1
					+ "Link)_all_"
					+ _aformat2
					+ ".elementAt(i);");
			_out.println(
				"\t\t\tif (temp1."
					+ _sourceformat2
					+ "._is_equivalent(before)) exist = true;");
			_out.println("\t\t\ti++;");
			_out.println("\t\t}");
			_out.println("\t\tif(exist) {");
			_out.println(
				"\t\t"
					+ _aformat1
					+ "Link temp = new "
					+ _aformat1
					+ "Link("
					+ _sourceformat2
					+ ", "
					+ _destformat2
					+ ");");
			_out.println(
				"\t\t_all_" + _aformat2 + ".insertElementAt(temp, i-1);");
			_out.println("\t\t}");
			_out.println(
				"\t\telse throw new org.omg.mof.Reflective.NotFound() ;");
			_out.println("\t\t}");
		}

		if (_dest_chang
			&& _dest_navig
			&& _source_chang
			&& ((_dest_upper > 1) || (_dest_upper == -1))
			&& _dest_ordered) {
			_out.println("\t\t// Operation add_before" + _destformat2);
			_out.println(
				"\tpublic void add_before_"
					+ _destformat2
					+ "("
					+ _sourceformat1
					+ "  "
					+ _sourceformat2
					+ ",  "
					+ _destformat1
					+ "  "
					+ _destformat2
					+ ", "
					+ _destformat1
					+ " before) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ ");
			_out.println("\t\tboolean exist = false;");
			_out.println("\t\tint i= 0;");
			_out.println(
				"\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
			_out.println(
				"\t\t\t"
					+ _aformat1
					+ "Link temp1= ("
					+ _aformat1
					+ "Link)_all_"
					+ _aformat2
					+ ".elementAt(i);");
			_out.println(
				"\t\t\tif (temp1."
					+ _destformat2
					+ "._is_equivalent(before)) exist = true;");
			_out.println("\t\t\ti++;");
			_out.println("\t\t}");
			_out.println("\t\tif(exist) {");
			_out.println(
				"\t\t"
					+ _aformat1
					+ "Link temp = new "
					+ _aformat1
					+ "Link("
					+ _sourceformat2
					+ ", "
					+ _destformat2
					+ ");");
			_out.println(
				"\t\t_all_" + _aformat2 + ".insertElementAt(temp, i-1);");
			_out.println("\t\t}");
			_out.println(
				"\t\telse throw new org.omg.mof.Reflective.NotFound() ;");
			_out.println("\t\t}");
		}

		if (_source_navig && _source_chang) {
			_out.println("\t\t// Operation modify" + _sourceformat2);
			_out.println(
				"\tpublic void modify_"
					+ _sourceformat2
					+ "("
					+ _sourceformat1
					+ "  "
					+ _sourceformat2
					+ ", "
					+ _destformat1
					+ "  "
					+ _destformat2
					+ ", "
					+ _sourceformat1
					+ " new_"
					+ _sourceformat2
					+ ") throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ ");
			_out.println("\t\tboolean exist = false;");
			_out.println("\t\tint i= 0;");
			_out.println(
				"\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
			_out.println(
				"\t\t\t"
					+ _aformat1
					+ "Link temp1= ("
					+ _aformat1
					+ "Link)_all_"
					+ _aformat2
					+ ".elementAt(i);");
			_out.println(
				"\t\t\tif (temp1."
					+ _sourceformat2
					+ "._is_equivalent("
					+ _sourceformat2
					+ ") && temp1."
					+ _destformat2
					+ "._is_equivalent("
					+ _destformat2
					+ ")) exist = true;");
			_out.println("\t\t\ti++;");
			_out.println("\t\t}");
			_out.println("\t\tif(exist) {");
			_out.println(
				"\t\t"
					+ _aformat1
					+ "Link temp = new "
					+ _aformat1
					+ "Link(new_"
					+ _sourceformat2
					+ ", "
					+ _destformat2
					+ ");");
			_out.println("\t\t_all_" + _aformat2 + ".setElementAt(temp, i-1);");
			_out.println("\t\t}");
			_out.println(
				"\t\telse throw new org.omg.mof.Reflective.NotFound() ;");
			_out.println("\t\t}");
		}

		if (_dest_navig && _dest_chang) {
			_out.println("\t\t// Operation modify" + _sourceformat2);
			_out.println(
				"\tpublic void modify_"
					+ _destformat2
					+ " ("
					+ _sourceformat1
					+ "  "
					+ _sourceformat2
					+ ", "
					+ _destformat1
					+ "  "
					+ _destformat2
					+ ", "
					+ _destformat1
					+ " new_"
					+ _destformat2
					+ ") throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ ");
			_out.println("\t\tboolean exist = false;");
			_out.println("\t\tint i= 0;");
			_out.println(
				"\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
			_out.println(
				"\t\t\t"
					+ _aformat1
					+ "Link temp1= ("
					+ _aformat1
					+ "Link)_all_"
					+ _aformat2
					+ ".elementAt(i);");
			_out.println(
				"\t\t\tif (temp1."
					+ _sourceformat2
					+ "._is_equivalent("
					+ _sourceformat2
					+ ") && temp1."
					+ _destformat2
					+ "._is_equivalent("
					+ _destformat2
					+ ")) exist = true;");
			_out.println("\t\t\ti++;");
			_out.println("\t\t}");
			_out.println("\t\tif(exist) {");
			_out.println(
				"\t\t"
					+ _aformat1
					+ "Link temp = new "
					+ _aformat1
					+ "Link("
					+ _sourceformat2
					+ ", new_"
					+ _destformat2
					+ ");");
			_out.println("\t\t_all_" + _aformat2 + ".setElementAt(temp, i-1);");
			_out.println("\t\t}");
			_out.println(
				"\t\telse throw new org.omg.mof.Reflective.NotFound() ;");
			_out.println("\t\t}");
		}

		if (_source_chang && _dest_chang) {
			_out.println(
				"\tpublic void remove ("
					+ _sourceformat1
					+ "  "
					+ _sourceformat2
					+ ", "
					+ _destformat1
					+ "  "
					+ _destformat2
					+ ") throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ ");
			_out.println("\t\tboolean exist = false;");
			_out.println("\t\tint i= 0;");
			_out.println(
				"\t\twhile((i< _all_" + _aformat2 + ".size())&& !exist){");
			_out.println(
				"\t\t\t"
					+ _aformat1
					+ "Link temp1= ("
					+ _aformat1
					+ "Link)_all_"
					+ _aformat2
					+ ".elementAt(i);");
			_out.println(
				"\t\t\tif (temp1."
					+ _sourceformat2
					+ "._is_equivalent("
					+ _sourceformat2
					+ ") && temp1."
					+ _destformat2
					+ "._is_equivalent("
					+ _destformat2
					+ ")) exist = true;");
			_out.println("\t\t\ti++;");
			_out.println("\t\t}");
			_out.println("\t\tif(exist) {");
			_out.println("\t\t_all_" + _aformat2 + ".removeElementAt(i-1);");
			_out.println("\t\t}");
			_out.println(
				"\t\telse throw new org.omg.mof.Reflective.NotFound() ;");
			_out.println("\t\t}");
		}
		_out.println("}");
	}
	/**
	 * Gets the helper
	 * @return Returns a Helper
	 */
	public Helper getHelper() {
		return helper;
	}
	/**
	 * Sets the helper
	 * @param helper The helper to set
	 */
	public void setHelper(Helper helper) {
		this.helper = helper;
	}

	/**
	 * Gets the templates
	 * @return Returns a Templates
	 */
	public Templates getTemplates() {
		return templates;
	}
	/**
	 * Sets the templates
	 * @param templates The templates to set
	 */
	public void setTemplates(Templates templates) {
		this.templates = templates;
	}

}