/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl2javaImpl;

import fr.lip6.src.modfact.util.Helper;
import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

public class PackageFactoryImplementation {
	//Helper
	Helper helper;
	
	
	//Log facility
	 Logger logger = Logger.getLogger("fr.lip6.src.mdafactory.generation.idl2javaImpl.PackageFactoryImplementation");	
	
	// La partie I/O
	private  java.io.PrintWriter _out;

	public  void setOut(java.io.PrintWriter _output) {
		logger.log(Level.CONFIG , "PackageFactoryImplementation setOut: "+_output);
		_out = _output;
	}
	public  void setOut(String _file)
		throws java.io.FileNotFoundException {
			logger.log(Level.CONFIG , "PackageFactoryImplementation setOut : "+_file);
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void setOut(java.io.File _file)
		throws java.io.FileNotFoundException, java.io.IOException {
			logger.log(Level.CONFIG , "PackageFactoryImplementation setOut : "+_file.getAbsolutePath());
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void closeFile() {
		_out.close();
	}
	public  void generateJava(org.omg.mof.Model.Package _package)
		throws
			org.omg.mof.Reflective.NotSet,
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		_out.println(
			"// le Code gnr du PackageFactory: "
				+ _package.name()
				+ "PackageFactory");
		packageFactoryImpl(_package);
		closeFile();
	}

	public  void packageFactoryImpl(org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError {
		//Dcalration du Package
		_out.print("package ");

		// les deux formats du nom du package
		String _nformat1 = helper.format1Idl2JavaConflict(_package.name());
		String className = helper.format1Idl2JavaConflict(_package.name()+"PackageFactory")+"Impl";
		String superClass = helper.format1Idl2JavaConflict(_package.name()+"PackageFactory")+"POA";
		String itemType = helper.format1Idl2JavaConflict(_package.name()+"Package");
		String itemClass = helper.format1Idl2JavaConflict(_package.name()+"Package")+"Impl";
		String _pformat2 = helper.format2(_package.name());

		// le nom du package
		_out.println(helper.javaPackage(_package) + " ;");

		_out.println(
			"public class "
				+ className
				+ " extends "
				+ superClass
				+ " {");
		org.omg.mof.Model.ModelElement[] _contents = _package.contents();
		java.util.Vector _classes = new java.util.Vector();

		for (int i = 0; i < _contents.length; i++) {
			if (_contents[i]._is_a(org.omg.mof.Model.ClassHelper.id()))
				_classes.addElement(
					org.omg.mof.Model.ClassHelper.narrow(_contents[i]));
		}
		java.util.Vector _classes_ordered = new java.util.Vector();
		while (_classes.size() != 0) {
			org.omg.mof.Model.Class _courant = null;
			for (int i = 0; i < _classes.size(); i++) {
				_courant = (org.omg.mof.Model.Class) _classes.elementAt(i);
				org.omg.mof.Model.GeneralizableElement[] _supertypes =
					_courant.supertypes();
				boolean _is_top = true;
				for (int j = 0; j < _supertypes.length; j++) {
					if (helper.contains(_classes, _supertypes[j]))
						_is_top = false;
				}
				if (_is_top) {
					_classes_ordered.addElement(_courant);
					_classes.removeElement(_courant);
				}
			}
		}

		java.util.Vector _attributes = new java.util.Vector();
		for (int j = 0; j < _classes_ordered.size(); j++) {
			java.util.Vector _attributes_temp =
				helper.attributsForClass(
					(org.omg.mof.Model.Class) _classes_ordered.elementAt(j),
					org.omg.mof.Model.ScopeKind.classifier_level,
					true);
			for (int i = 0; i < _attributes_temp.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(
						org
							.omg
							.mof
							.Model
							.MofAttribute) _attributes_temp
							.elementAt(
						i);
				_attributes.addElement(_current);
			}
		}

		//
		java.util.Vector _attributes_name =
			new java.util.Vector(_attributes.size());
		for (int i = 0; i < _attributes.size(); i++) {
			org.omg.mof.Model.MofAttribute _current =
				(org.omg.mof.Model.MofAttribute) _attributes.elementAt(i);
			String _attributeqname = " ";
			for (int j = 0; j < _current.qualified_name().length; j++) {
				if (j > 0)
					_attributeqname =
						helper.format2(_current.qualified_name()[j])
							+ "_"
							+ _attributeqname;
				else
					_attributeqname =
						helper.format2(_current.qualified_name()[j]);
			}
			_attributes_name.addElement(_attributeqname);
		}

		//
		_out.print(
			"\tpublic "
				+ itemType
				+ " create_"
				+ _pformat2
				+ "_package(");
		for (int i = 0; i < _attributes.size(); i++) {
			org.omg.mof.Model.MofAttribute _current =
				(org.omg.mof.Model.MofAttribute) _attributes.elementAt(i);
			String _current_type = helper.javaType(_current.type());
			String _attributeqname = (String) _attributes_name.elementAt(i);

			if (!((i != 0) || (i != (_attributes.size() - 1))))
				_out.print(", ");

			if ((_current.multiplicity().upper > 1)
				|| (_current.multiplicity().upper == -1))
				_out.print(_current_type + "[] " + _attributeqname);
			else
				_out.print(_current_type + " " + _attributeqname);
		}
		_out.println(") throws org.omg.mof.Reflective.MofError {");
		_out.print(
			"\t\t"
				+ itemClass
				+ " _"
				+ _pformat2
				+ "_package = new "
				+ itemClass
				+ "(");
		for (int i = 0; i < _attributes_name.size(); i++) {
			String _attributeqname = (String) _attributes_name.elementAt(i);
			if (!((i != 0) || (i != (_attributes.size() - 1))))
				_out.print(", ");
			_out.print(_attributeqname);
		}
		_out.println(");");

		_out.println("\t\ttry {");
		_out.println("\t\t_poa().activate_object(_" + _pformat2 + "_package);");
		_out.println(
			"\t\torg.omg.CORBA.Object obj = _poa().servant_to_reference(_"
				+ _pformat2
				+ "_package);");
		_out.println("\t\treturn " + itemType + "Helper.narrow(obj);");
		_out.println("\t\t\t}");
		_out.println("\t\tcatch (java.lang.Exception ex) {");
		_out.println("\t\tex.printStackTrace();");
		_out.println("\t\tSystem.exit(0);");
		_out.println("\t\t\t}");
		_out.println("\t\treturn null;");
		_out.println("\t\t}");
		_out.println("\t}");
	}
	/**
	 * Gets the helper
	 * @return Returns a Helper
	 */
	public Helper getHelper() {
		return helper;
	}
	/**
	 * Sets the helper
	 * @param helper The helper to set
	 */
	public void setHelper(Helper helper) {
		this.helper = helper;
	}

}