/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl2javaImpl;

import fr.lip6.src.modfact.util.Helper;
import java.util.logging.LogManager;
import java.util.logging.Logger;

public class Templates {
	//Helper
	Helper helper;
	
	
	//Log facility
	 Logger logger = LogManager.getLogManager().getLogger("fr.lip6.src.mdafactory.generation.idl2javaImpl.Templates");

	//Attribute Template
	//une table de hashage pour minimiser le retratement des attributs
	private  java.util.Hashtable _attributs = new java.util.Hashtable();

	public  String attributeTemplate(
		org.omg.mof.Model.MofAttribute _attribute)
		throws org.omg.mof.Reflective.MofError {

		//voir si c'est dja clacul
		String _key = _attribute.ref_mof_id();
		if (_attributs.containsKey(_key)) {
			String _temp = (String) _attributs.get(_key);
			return _temp;
		} else {
			//dcalration de la chaine qui contiendra la code
			String _code_attribute = "\t\t//" + _attribute.annotation() + "\n";

			String _type_format1 = helper.javaType(_attribute.type());
			String _aformat2 = helper.format2(_attribute.name());
			org.omg.mof.Model.MultiplicityType _multiplicity =
				_attribute.multiplicity();
			int _upper = _multiplicity.upper;
			int _lower = _multiplicity.lower;
			boolean _is_ordered = _multiplicity.isOrdered;
			boolean _is_unique = _multiplicity.isUnique;
			boolean _is_changeable = _attribute.is_changeable();
			boolean _is_derived = _attribute.is_derived();

			//Dclaration de l'attribut
			if ((_upper > 1) || (_upper == -1))
				_code_attribute =
					_code_attribute.concat(
						"\tprivate java.util.Vector  _"
							+ _aformat2
							+ "s = new java.util.Vector();\n");
			else
				_code_attribute =
					_code_attribute.concat(
						"\tprivate "
							+ _type_format1
							+ "  _"
							+ _aformat2
							+ " ;\n");
			if ((_lower == 0) && (_upper == 1))
				_code_attribute =
					_code_attribute.concat(
						"\tprivate boolean _exist_"
							+ _aformat2
							+ " = false;\n");

			//Dclaration des mthodes qui convient
			if ((_lower == 0) && (_upper == 1)) {
				if (_is_derived) {
					_code_attribute =
						_code_attribute.concat(
							"\tpublic "
								+ _type_format1
								+ " "
								+ _aformat2
								+ "() throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError { \n");
					_code_attribute =
						_code_attribute.concat(
							"\t\t//inserer le code contenu\n");
					_code_attribute = _code_attribute.concat("\t\t}\n");
				} else {
					_code_attribute =
						_code_attribute.concat(
							"\tpublic "
								+ _type_format1
								+ " "
								+ _aformat2
								+ "() throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError { \n");
					_code_attribute =
						_code_attribute.concat(
							"\t\tif (_exist_"
								+ _aformat2
								+ ") return _"
								+ _aformat2
								+ ";\n");
					_code_attribute =
						_code_attribute.concat(
							"\t\telse throw new org.omg.mof.Reflective.NotSet();\n");
					_code_attribute = _code_attribute.concat("\t\t}\n");
				}
			}

			if ((_lower == 1) && (_upper == 1)) {
				if (_is_derived) {
					_code_attribute =
						_code_attribute.concat(
							"\tpublic "
								+ _type_format1
								+ " "
								+ _aformat2
								+ "() throws org.omg.mof.Reflective.MofError {\n ");
					_code_attribute =
						_code_attribute.concat(
							"\t\t//inserer le code contenu\n");
					_code_attribute = _code_attribute.concat("\t\t}\n");
				} else {
					_code_attribute =
						_code_attribute.concat(
							"\tpublic "
								+ _type_format1
								+ " "
								+ _aformat2
								+ "() throws org.omg.mof.Reflective.MofError {\n ");
					_code_attribute =
						_code_attribute.concat(
							"\t\treturn _" + _aformat2 + ";\n");
					_code_attribute = _code_attribute.concat("\t\t}\n");
				}
			}

			if ((_upper > 1) || (_upper == -1)) {
				if (_is_derived) {
					_code_attribute =
						_code_attribute.concat(
							"\tpublic "
								+ _type_format1
								+ "[]  "
								+ _aformat2
								+ "() throws org.omg.mof.Reflective.MofError { \n");
					_code_attribute =
						_code_attribute.concat(
							"\t\t//inserer le code contenu\n");
					_code_attribute = _code_attribute.concat("\t\t}\n");
				} else {
					_code_attribute =
						_code_attribute.concat(
							"\tpublic "
								+ _type_format1
								+ "[]  "
								+ _aformat2
								+ "() throws org.omg.mof.Reflective.MofError { \n");
					_code_attribute =
						_code_attribute.concat(
							"\t\t"
								+ _type_format1
								+ "[] temp1 = new "
								+ _type_format1
								+ "[_"
								+ _aformat2
								+ "s.size()];\n");
					_code_attribute =
						_code_attribute.concat(
							"\t\tfor(int i=0; i< _"
								+ _aformat2
								+ "s.size(); i++) temp1[i] = ("
								+ _type_format1
								+ ")_"
								+ _aformat2
								+ "s.elementAt(i);\n");
					_code_attribute =
						_code_attribute.concat("\t\treturn temp1;\n");
					_code_attribute = _code_attribute.concat("\t\t}\n");
				}
			}

			if ((_upper == 1) && (_is_changeable)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void set_"
							+ _aformat2
							+ "("
							+ _type_format1
							+ " new_value) throws org.omg.mof.Reflective.MofError { \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\t_" + _aformat2 + " = new_value ;\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if (((_upper > 1) || (_upper == -1)) && (_is_changeable)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void set_"
							+ _aformat2
							+ "("
							+ _type_format1
							+ "[] new_value) throws org.omg.mof.Reflective.MofError { \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\t_" + _aformat2 + "s.removeAllElements();\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tfor(int i= 0; i< new_value.length ; i++) _"
							+ _aformat2
							+ "s.addElement(new_value[i]);\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_lower == 0) && (_upper == 1) && (_is_changeable)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void unset_"
							+ _aformat2
							+ "() throws org.omg.mof.Reflective.MofError{ \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\t_exist_" + _aformat2 + " = false;\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_upper > 1) || (_upper == -1) && (_is_changeable)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void add_"
							+ _aformat2
							+ " ("
							+ _type_format1
							+ " new_element) throws org.omg.mof.Reflective.MofError{ \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\t_" + _aformat2 + "s.addElement(new_element);\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_upper > 1)
				|| (_upper == -1)
				&& (_is_changeable)
				&& (_is_ordered)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void add_"
							+ _aformat2
							+ "_before ("
							+ _type_format1
							+ " new_element, "
							+ _type_format1
							+ " before_element) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tif(_"
							+ _aformat2
							+ "s.contains(before_element)) {\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tint i = _"
							+ _aformat2
							+ "s.indexOf(before_element);\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\t_"
							+ _aformat2
							+ "s.insertElementAt(new_element, i);\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\telse throw new org.omg.mof.Reflective.NotFound() ;\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_upper > 1)
				|| (_upper == -1)
				&& (_is_changeable)
				&& (_is_ordered)
				&& (!_is_unique)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void add_"
							+ _aformat2
							+ "_at ("
							+ _type_format1
							+ " new_element, int position) throws org.omg.mof.Reflective.BadPosition, org.omg.mof.Reflective.MofError{ \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tif(_"
							+ _aformat2
							+ "s.size()> position) _"
							+ _aformat2
							+ "s.insertElementAt(new_element, position);\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\telse throw new org.omg.mof.Reflective.BadPosition() ;\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_upper > 1) || (_upper == -1) && (_is_changeable)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void modify_"
							+ _aformat2
							+ " ("
							+ _type_format1
							+ " old_element,"
							+ _type_format1
							+ " new_element) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tif( _"
							+ _aformat2
							+ "s.contains(old_element)) {\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tint i =_"
							+ _aformat2
							+ "s.indexOf(old_element);\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\t_"
							+ _aformat2
							+ "s.setElementAt(new_element, i);\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\telse throw new org.omg.mof.Reflective.NotFound();\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_upper > 1)
				|| (_upper == -1)
				&& (_is_changeable)
				&& (_is_ordered)
				&& (!_is_unique)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void modify_"
							+ _aformat2
							+ "_at ("
							+ _type_format1
							+ " new_element, int position) throws org.omg.mof.Reflective.BadPosition, org.omg.mof.Reflective.MofError{\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tif(_"
							+ _aformat2
							+ "s.size()> position) _"
							+ _aformat2
							+ "s.setElementAt(new_element, position);\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\telse throw new org.omg.mof.Reflective.BadPosition() ;\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_upper > 1)
				|| (_upper == -1)
				&& (_upper != _lower)
				&& (_is_changeable)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void remove_"
							+ _aformat2
							+ " ("
							+ _type_format1
							+ " old_element ) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError { \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tif(_"
							+ _aformat2
							+ "s.contains(old_element)) _"
							+ _aformat2
							+ "s.removeElement(old_element);\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\telse throw new org.omg.mof.Reflective.NotFound() ;\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}

			if ((_upper > 1)
				|| (_upper == -1)
				&& (_upper != _lower)
				&& (_is_changeable)
				&& (_is_ordered)
				&& (!_is_unique)) {
				_code_attribute =
					_code_attribute.concat(
						"\tpublic void remove_"
							+ _aformat2
							+ "_at (int position) throws org.omg.mof.Reflective.BadPosition, org.omg.mof.Reflective.MofError { \n");
				_code_attribute =
					_code_attribute.concat(
						"\t\tif(_"
							+ _aformat2
							+ "s.size()> position) _"
							+ _aformat2
							+ "s.remove( position);\n");
				_code_attribute =
					_code_attribute.concat(
						"\t\telse throw new org.omg.mof.Reflective.BadPosition() ;\n");
				_code_attribute = _code_attribute.concat("\t\t}\n");
			}
			_attributs.put(_key, _code_attribute);
			return _code_attribute;
		}
	}

	//Reference Template
	//une table de hashage pour minimiser le retratement des attributs
	private  java.util.Hashtable _references = new java.util.Hashtable();

	public  String referenceTemplate(
		org.omg.mof.Model.Reference _reference)
		throws org.omg.mof.Reflective.MofError {

		//voir si c'est dja clacul
		String _key = _reference.ref_mof_id();
		if (_references.containsKey(_key)) {
			String _temp = (String) _references.get(_key);
			return _temp;
		} else {
			//dcalration de la chaine qui contiendra la code
			String _code_reference = "\t\t//" + _reference.annotation() + "\n";

			String _type_format1 = helper.javaQualifiedName(_reference.type());
			String _aformat2 = helper.format2(_reference.name());
			org.omg.mof.Model.MultiplicityType _multiplicity =
				_reference.multiplicity();
			int _upper = _multiplicity.upper;
			int _lower = _multiplicity.lower;
			boolean _is_ordered = _multiplicity.isOrdered;
			boolean _is_unique = _multiplicity.isUnique;
			boolean _is_changeable = _reference.is_changeable();

			// Dclaration des mthode de la rfrence
			if ((_upper > 1) || (_upper == -1))
				_code_reference =
					_code_reference.concat(
						"\tprivate java.util.Vector  _"
							+ _aformat2
							+ "s = new java.util.Vector();\n");
			else
				_code_reference =
					_code_reference.concat(
						"\tprivate "
							+ _type_format1
							+ "  _"
							+ _aformat2
							+ " = null;\n");

			//Dclaration des mthodes qui convient
			if ((_lower == 0) && (_upper == 1)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic "
							+ _type_format1
							+ " "
							+ _aformat2
							+ "() throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError { \n");
				_code_reference =
					_code_reference.concat(
						"\t\tif (_"
							+ _aformat2
							+ "!= null) return _"
							+ _aformat2
							+ ";\n");
				_code_reference =
					_code_reference.concat(
						"\t\telse throw new org.omg.mof.Reflective.NotSet();\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_lower == 1) && (_upper == 1)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic "
							+ _type_format1
							+ " "
							+ _aformat2
							+ "() throws org.omg.mof.Reflective.MofError { \n");
				_code_reference =
					_code_reference.concat("\t\treturn _" + _aformat2 + ";\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_upper > 1) || (_upper == -1)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic "
							+ _type_format1
							+ "[]  "
							+ _aformat2
							+ "() throws org.omg.mof.Reflective.MofError { \n");
				_code_reference =
					_code_reference.concat(
						"\t\t"
							+ _type_format1
							+ "[] temp1 = new "
							+ _type_format1
							+ "[_"
							+ _aformat2
							+ "s.size()];\n");
				_code_reference =
					_code_reference.concat(
						"\t\tfor(int i=0; i< _"
							+ _aformat2
							+ "s.size(); i++) temp1[i] = ("
							+ _type_format1
							+ ")_"
							+ _aformat2
							+ "s.elementAt(i);\n");
				_code_reference = _code_reference.concat("\t\treturn temp1;\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_upper == 1) && (_is_changeable)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic void set_"
							+ _aformat2
							+ "("
							+ _type_format1
							+ " new_value) throws org.omg.mof.Reflective.MofError { \n");
				_code_reference =
					_code_reference.concat(
						"\t\t_" + _aformat2 + " = new_value ;\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if (((_upper > 1) || (_upper == -1)) && (_is_changeable)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic void set_"
							+ _aformat2
							+ "("
							+ _type_format1
							+ "[] new_value) throws org.omg.mof.Reflective.MofError { \n");
				_code_reference =
					_code_reference.concat(
						"\t\t_" + _aformat2 + "s.removeAllElements();\n");
				_code_reference =
					_code_reference.concat(
						"\t\tfor(int i= 0; i< new_value.length ; i++) _"
							+ _aformat2
							+ "s.addElement(new_value[i]);\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_lower == 0) && (_upper == 1) && (_is_changeable)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic void unset_"
							+ _aformat2
							+ "() throws org.omg.mof.Reflective.MofError{ \n");
				_code_reference =
					_code_reference.concat("\t\t_" + _aformat2 + " = null;\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_upper > 1) || (_upper == -1) && (_is_changeable)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic void add_"
							+ _aformat2
							+ " ("
							+ _type_format1
							+ " new_element) throws org.omg.mof.Reflective.MofError{ \n");
				_code_reference =
					_code_reference.concat(
						"\t\t_" + _aformat2 + "s.addElement(new_element);\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_upper > 1)
				|| (_upper == -1)
				&& (_is_changeable)
				&& (_is_ordered)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic void add_"
							+ _aformat2
							+ "_before ("
							+ _type_format1
							+ " new_element, "
							+ _type_format1
							+ " before_element) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ \n");
				_code_reference =
					_code_reference.concat(
						"\t\tif(_"
							+ _aformat2
							+ "s.contains(before_element)) {\n");
				_code_reference =
					_code_reference.concat(
						"\t\tint i = _"
							+ _aformat2
							+ "s.indexOf(before_element);\n");
				_code_reference =
					_code_reference.concat(
						"\t\t_"
							+ _aformat2
							+ "s.insertElementAt(new_element, i);\n");
				_code_reference = _code_reference.concat("\t\t}\n");
				_code_reference =
					_code_reference.concat(
						"\t\telse throw new org.omg.mof.Reflective.NotFound() ;\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_upper > 1) || (_upper == -1) && (_is_changeable)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic void modify_"
							+ _aformat2
							+ " ("
							+ _type_format1
							+ " old_element,"
							+ _type_format1
							+ " new_element) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{ \n");
				_code_reference =
					_code_reference.concat(
						"\t\tif( _"
							+ _aformat2
							+ "s.contains(old_element)) {\n");
				_code_reference =
					_code_reference.concat(
						"\t\tint i =_"
							+ _aformat2
							+ "s.indexOf(old_element);\n");
				_code_reference =
					_code_reference.concat(
						"\t\t_"
							+ _aformat2
							+ "s.setElementAt(new_element, i);\n");
				_code_reference = _code_reference.concat("\t\t}\n");
				_code_reference =
					_code_reference.concat(
						"\t\telse throw new org.omg.mof.Reflective.NotFound();\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}

			if ((_upper > 1)
				|| (_upper == -1)
				&& (_upper != _lower)
				&& (_is_changeable)) {
				_code_reference =
					_code_reference.concat(
						"\tpublic void remove_"
							+ _aformat2
							+ " ("
							+ _type_format1
							+ " old_element ) throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError { \n");
				_code_reference =
					_code_reference.concat(
						"\t\tif(_"
							+ _aformat2
							+ "s.contains(old_element)) _"
							+ _aformat2
							+ "s.removeElement(old_element);\n");
				_code_reference =
					_code_reference.concat(
						"\t\telse throw new org.omg.mof.Reflective.NotFound() ;\n");
				_code_reference = _code_reference.concat("\t\t}\n");
			}
			_references.put(_key, _code_reference);
			return _code_reference;
		}
	}

	//Attribute Template
	//une table de hashage pour minimiser le retratement des attributs
	private  java.util.Hashtable _operations = new java.util.Hashtable();

	public  String operationTemplate(
		org.omg.mof.Model.Operation _operation)
		throws org.omg.mof.Reflective.MofError {

		//voir si c'est dja clacul
		String _key = _operation.ref_mof_id();
		if (_operations.containsKey(_key)) {
			String _temp = (String) _operations.get(_key);
			return _temp;
		} else {

			String _code_operation = "\t\t//" + _operation.annotation() + "\n";
			String _oformat2 = helper.format2(_operation.name());

			org.omg.mof.Model.ModelElement[] _contents = _operation.contents();

			boolean bool = false;
			int j = 0;
			while (!bool && (j < _contents.length)) {
				org.omg.mof.Model.Parameter _parameter =
					org.omg.mof.Model.ParameterHelper.narrow(_contents[j]);
				if ((_parameter.direction())
					.equals(org.omg.mof.Model.DirectionKind.return_dir)) {
					bool = true;
					if ((_parameter.multiplicity().upper > 1)
						|| (_parameter.multiplicity().upper == -1))
						_code_operation =
							_code_operation.concat(
								"\tpublic "
									+ helper.javaType(_parameter.type())
									+ "[] "
									+ _oformat2
									+ " (");
					else
						_code_operation =
							_code_operation.concat(
								"\tpublic "
									+ helper.javaType(_parameter.type())
									+ " "
									+ _oformat2
									+ "(");
					j = j + 1;
				}
			}
			if (!bool)
				_code_operation = _code_operation.concat("\tpublic void ");
			for (int i = 0; i < _contents.length; i++) {
				org.omg.mof.Model.Parameter _parameter =
					org.omg.mof.Model.ParameterHelper.narrow(_contents[i]);
				String _type_format1 = helper.javaType(_parameter.type());
				String _pformat2 = helper.format2(_parameter.name());
				if (!(_parameter
					.direction()
					.equals(org.omg.mof.Model.DirectionKind.return_dir))) {
					if ((_parameter.multiplicity().upper > 1)
						|| (_parameter.multiplicity().upper == -1))
						_code_operation =
							_code_operation.concat(
								_type_format1 + "[] " + _pformat2 + " (");
					else
						_code_operation =
							_code_operation.concat(
								_type_format1 + " " + _oformat2 + "(");
					if (i != (_contents.length - 1))
						_code_operation = _code_operation.concat(", ");
				}
			}
			_code_operation = _code_operation.concat(") throws ");
			org.omg.mof.Model.MofException[] _exceptions =
				_operation.exceptions();
			for (int i = 0; i < _exceptions.length; i++) {
				org.omg.mof.Model.MofException _exception = _exceptions[i];
				String _eformat1 = helper.format1Idl2JavaConflict(_exception.name());
				_code_operation = _code_operation.concat(_eformat1);
				_code_operation = _code_operation.concat(", ");
			}
			_code_operation =
				_code_operation.concat("org.omg.mof.Reflective.MofError {\n");
			_code_operation =
				_code_operation.concat("\t\t//inserer le code contenu\n");
			_code_operation =
				_code_operation.concat(
					"\t\tthrow new org.omg.CORBA.NO_IMPLEMENT(\" method not implemented \",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_operation = _code_operation.concat("\t\t}\n");
			_references.put(_key, _code_operation);
			return _code_operation;
		}
	}

	//Ajout de la partie RefBaseObject
	private  String _code_ref_base_object = null;
	public  String refBaseObjectTemplate() {

		// voir si c'ets dja Calcul
		if (_code_ref_base_object != null)
			return _code_ref_base_object;

		else {
			String _code_temp = "";
			_code_temp =
				_code_temp.concat("\t\t//Ajout de la partie RefBaseObject \n");
			_code_temp = _code_temp.concat("\t\t// Operation ref_mof_id\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public java.lang.String ref_mof_id(){\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    int id = _orb().object_to_string(_this()).hashCode();\n");
			_code_temp =
				_code_temp.concat("\t\t     return String.valueOf(id);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			_code_temp =
				_code_temp.concat("\t\t  // Operation ref_meta_object\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public org.omg.mof.Reflective.RefObject ref_meta_object(){\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_meta_object method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t    }\n");

			_code_temp = _code_temp.concat("\t\t // Operation ref_itself\n");
			_code_temp =
				_code_temp.concat(
					"\t\t public boolean ref_itself(org.omg.mof.Reflective.RefBaseObject other_object){\n");
			_code_temp =
				_code_temp.concat(
					"\t\t     String id_obj = other_object.ref_mof_id();\n");
			_code_temp =
				_code_temp.concat(
					"\t\t     if (ref_mof_id().equals(id_obj)) return true;\n");
			_code_temp = _code_temp.concat("\t\t     else return false;\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			_code_temp =
				_code_temp.concat("\t\t // Operation ref_immediate_package\n");
			_code_temp =
				_code_temp.concat(
					"\t\t public org.omg.mof.Reflective._RefPackage ref_immediate_package(){\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_immediate_package method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t }\n");

			_code_temp =
				_code_temp.concat("\t\t // Operation ref_outermost_package\n");
			_code_temp =
				_code_temp.concat(
					"\t\t public org.omg.mof.Reflective._RefPackage ref_outermost_package(){\n");
			_code_temp =
				_code_temp.concat(
					"\t\t throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_moutermost_package method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			_code_temp = _code_temp.concat("\t\t  // Operation ref_delete\n");
			_code_temp =
				_code_temp.concat(
					"\t\t public void ref_delete() throws org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_delete method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			//Stocker
			_code_ref_base_object = _code_temp;
			return _code_ref_base_object;
		}

	}

	//Ajout de la partie RefAssociation
	private  String _code_ref_association = null;
	public  String refAssociationTemplate() {

		// voir si c'ets dja Calcul
		if (_code_ref_association != null)
			return _code_ref_association;

		else {
			String _code_temp = "";
			_code_temp = _code_temp.concat("\t\t// Operation ref_all_links\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	public org.omg.mof.Reflective.RefObject[][] ref_all_links(){\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_all_links method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t	}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_link_exists\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public boolean ref_link_exists(org.omg.mof.Reflective.RefObject[] some_link)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throws org.omg.mof.Reflective.MofError{\n");
			_code_temp =
				_code_temp.concat(
					"\t\t     throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_link_exists method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp = _code_temp.concat("\t\t// Operation ref_query\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public org.omg.mof.Reflective.RefObject[] ref_query(org.omg.mof.Reflective.RefObject query_end, org.omg.mof.Reflective.RefObject query_object)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throws org.omg.mof.Reflective.MofError{\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_query method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp = _code_temp.concat("\t\t// Operation ref_add_link\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public void ref_add_link(org.omg.mof.Reflective.RefObject[] new_link)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throws org.omg.mof.Reflective.MofError{\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_add_link method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_add_link_before\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public void ref_add_link_before(org.omg.mof.Reflective.RefObject[] new_link, org.omg.mof.Reflective.RefObject position_end, org.omg.mof.Reflective.RefObject before)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_add_link_before method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_modify_link\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public void ref_modify_link(org.omg.mof.Reflective.RefObject[] old_link, org.omg.mof.Reflective.RefObject position_end, org.omg.mof.Reflective.RefObject new_object)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError{\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_modify_link method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_remove_link\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  public void ref_remove_link(org.omg.mof.Reflective.RefObject[] old_link)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t    throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_remove_link method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t }\n");
			//Stocker
			_code_ref_association = _code_temp;
			return _code_ref_association;
		}
	}

	//Ajout de la partie RefObject
	private  String _code_ref_object = null;
	public  String refObjectTemplate() {

		// voir si c'ets dja Calcul
		if (_code_ref_object != null)
			return _code_ref_object;

		else {
			String _code_temp = "";
			_code_temp =
				_code_temp.concat("\t\t    //Ajout de la partie  RefObject\n");
			_code_temp =
				_code_temp.concat("\t\t// Operation ref_is_instance_of\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic boolean ref_is_instance_of(org.omg.mof.Reflective.RefObject some_class, boolean consider_subtypes) {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_is_instance_of method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_create_instance\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic org.omg.mof.Reflective.RefObject ref_create_instance(org.omg.CORBA.Any[] args) throws org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_create_instance method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_all_objects\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic org.omg.mof.Reflective.RefObject[] ref_all_objects(boolean include_subtypes){\n");
			_code_temp =
				_code_temp.concat(
					"\t\t throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_all_objects method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp = _code_temp.concat("\t\t// Operation ref_set_value\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_set_value(org.omg.mof.Reflective.RefObject feature, org.omg.CORBA.Any new_value) throws org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_set_value method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp = _code_temp.concat("\t\t// Operation ref_value\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic org.omg.CORBA.Any ref_value(org.omg.mof.Reflective.RefObject feature) throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_value method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_unset_value\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_unset_value() throws org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_unset_value method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp = _code_temp.concat("\t\t// Operation ref_add_value\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_add_value(org.omg.mof.Reflective.RefObject feature, org.omg.CORBA.Any new_element) throws org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_add_value method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_add_value_before\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_add_value_before(org.omg.mof.Reflective.RefObject feature, org.omg.CORBA.Any new_element, org.omg.CORBA.Any before_element)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	 throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_add_value_before method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_add_value_at\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_add_value_at(org.omg.mof.Reflective.RefObject feature, org.omg.CORBA.Any new_element, int position)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throws org.omg.mof.Reflective.BadPosition, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_add_value_at method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_modify_value\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_modify_value(org.omg.mof.Reflective.RefObject feature, org.omg.CORBA.Any old_element, org.omg.CORBA.Any new_element)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_modify_value method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_modify_value_at\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_modify_value_at(org.omg.mof.Reflective.RefObject feature, org.omg.CORBA.Any new_element, int position)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throws org.omg.mof.Reflective.BadPosition, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_modify_value_at method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_remove_value\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_remove_value(org.omg.mof.Reflective.RefObject feature, org.omg.CORBA.Any existing_element)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throws org.omg.mof.Reflective.NotFound, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	 throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_remove_value method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_remove_value_at\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic void ref_remove_value_at(org.omg.mof.Reflective.RefObject feature, int position)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throws org.omg.mof.Reflective.BadPosition, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_remove_value_at method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_immediate_composite\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic org.omg.mof.Reflective.RefObject ref_immediate_composite() {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_remove_value method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_outermost_composite\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic org.omg.mof.Reflective.RefObject ref_outermost_composite() {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_outermost_composite method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			_code_temp =
				_code_temp.concat("\t\t// Operation ref_invoke_operation(\n");
			_code_temp =
				_code_temp.concat(
					"\t\tpublic org.omg.CORBA.Any ref_invoke_operation(org.omg.mof.Reflective.RefObject requested_temp, org.omg.mof.Reflective.ValueTypeListHolder args)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	throws org.omg.mof.Reflective.OtherException, org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t	  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_invoke_operation( method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t}\n");

			//Stocker
			_code_ref_object = _code_temp;
			return _code_ref_object;
		}
	}

	//Ajout de la partie RefPackage
	private  String _code_ref_package = null;
	public  String refPackageTemplate() {

		// voir si c'ets dja Calcul
		if (_code_ref_package != null)
			return _code_ref_package;

		else {
			String _code_temp = "";
			_code_temp = _code_temp.concat("\t\t // Operation ref_class_ref\n");
			_code_temp =
				_code_temp.concat(
					"\t\t public org.omg.mof.Reflective.RefObject ref_class_ref(org.omg.mof.Reflective.RefObject _class)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throws org.omg.mof.Reflective.MofError{\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_class_ref method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			_code_temp =
				_code_temp.concat("\t\t // Operation ref_association_ref\n");
			_code_temp =
				_code_temp.concat(
					"\t\t public org.omg.mof.Reflective.RefAssociation ref_association_ref(org.omg.mof.Reflective.RefObject association)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throws org.omg.mof.Reflective.MofError {\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_association_ref method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			_code_temp =
				_code_temp.concat("\t\t // Operation ref_package_ref\n");
			_code_temp =
				_code_temp.concat(
					"\t\t public org.omg.mof.Reflective._RefPackage ref_package_ref(org.omg.mof.Reflective.RefObject _package)\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throws org.omg.mof.Reflective.MofError{\n");
			_code_temp =
				_code_temp.concat(
					"\t\t  throw new org.omg.CORBA.NO_IMPLEMENT(\"ref_package_ref method not implemented\",1 ,org.omg.CORBA.CompletionStatus.COMPLETED_NO);\n");
			_code_temp = _code_temp.concat("\t\t  }\n");

			//Stocker
			_code_ref_package = _code_temp;
			return _code_ref_package;
		}
	}
	/**
	 * Gets the helper
	 * @return Returns a Helper
	 */
	public Helper getHelper() {
		return helper;
	}
	/**
	 * Sets the helper
	 * @param helper The helper to set
	 */
	public void setHelper(Helper helper) {
		this.helper = helper;
	}

}