/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.jmi;


import java.util.Vector;

import org.omg.CORBA.TCKind;

import org.omg.mof.Model.DataType;
import org.omg.mof.Model.DataTypeHelper;
import org.omg.mof.Model.MofException;
import org.omg.mof.Model.MultiplicityType;
import org.omg.mof.Model.Parameter;
import org.omg.mof.Model.ParameterHelper;
import org.omg.mof.Reflective.MofError;

/**
 *
 */
public class ExceptionImplementationTemplate
	extends CommonImplementationTemplate {
		
	public void exceptionTemplate(MofException exce) throws MofError {
		//<<ANNOTATION TEMPLATE>>
		out.println("public class "+exce.name()+" extends java.jmi.reflect.RefException {");
		//Get Parameters
		Parameter[] parameters; 
		Vector paramsTmp = new Vector();
		for (int i = 0; i < exce.contents().length; i++) {
			Parameter parameter = ParameterHelper.narrow(exce.contents()[i]);
			paramsTmp.addElement(parameter);
		}
		parameters = new Parameter[paramsTmp.size()];
		for (int i=0 ; i < parameters.length ; i++) parameters[i]=(Parameter) paramsTmp.elementAt(i);
		
		//for each parameters
		for (int i=0 ; i < parameters.length ; i++) {
			out.println("\tprivate "+helper.jmiClassifierName(parameters[i].type())+" "+parameters[i].name()+";");
		}
		
		//constructor
		out.print("\tpublic "+exce.name()+"(");
		//for each parameter
		for (int i=0 ; i < parameters.length ; i++) {
			if (i!=0) out.print(",");
			out.print(helper.jmiClassifierName(parameters[i].type())+" "+parameters[i].name());
		}
		out.println(") {");
		out.println("\t\tsuper();");
		//for each parameter
		for (int i=0 ; i < parameters.length ; i++) {
			out.println("\t\tthis."+parameters[i].name()+"="+parameters[i].name()+";");
		}
		out.println("\t}");
		
		//for each parameter
		for (int i=0 ; i < parameters.length ; i++) {
			out.println("\tpublic "+helper.jmiClassifierName(parameters[i].type())+" "+accessorName(parameters[i])+"() {");
			out.println("\t\treturn this."+parameters[i].name());
			out.println("\t}");
		}
		
		out.println("}");
	}
	
	public String accessorName(Parameter param) throws MofError {
		String accessorName = param.name();
		MultiplicityType mult = param.multiplicity();
		//DataType
		boolean isBoolean = false;
		if (param.type()._is_a(DataTypeHelper.id())) {
			DataType type = DataTypeHelper.narrow(param.type());
			if (type.type_code().kind().equals(TCKind.tk_boolean)) isBoolean=true;
		}
		if (mult.lower==0 && mult.upper==1 && isBoolean)  {
			if (accessorName.matches("is*")) return accessorName;
			else return "is"+accessorName;
		}
		else return "get"+accessorName;
	}

}
