/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.jmi;

import org.omg.CORBA.TypeCodePackage.Bounds;
import org.omg.CORBA.TCKind;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.TypeCodePackage.BadKind;
import org.omg.mof.Model.DataType;
import org.omg.mof.Reflective.MofError;

/**
 * 
 */
public class StructureTypeInterfaceTemplate extends CommonInterfaceTemplate {
	public void structureTypeTemplate(DataType type) throws MofError , BadKind , Bounds{
		//
		//<<ANNOTATION TEMPLATE >>
		out.println("public interface "+type.name()+" extends javax.jmi.reflect.RefStruct {");
		//for each attribute
		TypeCode tc = type.type_code();
		for (int i=0 ; i < tc.member_count() ; i++) {
			out.println("\tpublic "+helper.idl2Java(tc.member_type(i).name())+" "+accessorName(tc.member_name(i),tc.member_type(0))+"() throws javax.jmi.reflect.JmiException;");
		}
		out.println("}");
	}
	
	public String accessorName(String memberName , TypeCode memberType) throws MofError {
		//DataType
		if (memberType.kind().equals(TCKind.tk_boolean)) {
			if (memberName.matches("is*")) return memberName;
			else return "is"+memberName;
		}
		else return "get"+memberName;
	}

}
