/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.io;

import fr.lip6.src.modfact.util.Helper;

public class Export {

	//les proprits
	private  Helper helper = new Helper();
	private  java.io.PrintWriter _out;
	private  org.omg.mof.Model.ModelPackage _MPackage;

	public  void setModelPackage(
		org.omg.mof.Model.ModelPackage _modelPackage)
		throws org.omg.mof.Reflective.MofError {
		_MPackage = _modelPackage;
	}

	public  void setOut(String _file)
		throws java.io.FileNotFoundException {
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void setOut(java.io.File _file)
		throws java.io.FileNotFoundException, java.io.IOException {
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void closeFile() {
		_out.close();
	}

	// les espaces d'indentations
	private  String space = " ";
	public  String beTag() {
		if (space.equalsIgnoreCase(" "))
			space = "";
		else
			space = space + "\t";
		return space;
	}

	public  String enTag() {
		String result = space;
		if (!result.equalsIgnoreCase("")) {
			space = space.substring(0, space.length() - 1);
		}
		return result;
	}
	public  String coTag() {
		String result = space;
		if (result.equalsIgnoreCase(" "))
			result = "";
		else
			result = space + "\t";
		return result;
	}

	// gnration du l'XML
	public  void export(org.omg.mof.Model.Package _Package)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.mof.Reflective.NotSet,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		packageModuleTemplate(_Package);
		closeFile();
	}

	// Tag Template
	public  void tagTemplate(
		org.omg.mof.Model.Tag _tag)
		throws org.omg.mof.Reflective.MofError ,org.omg.mof.Reflective.NotSet {

		if (_tag.tag_id().compareTo("org.omg.mof.idl_prefix")==0) {
		_out.println(beTag() + "<Model.Tag>");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>package</Model.ModelElement.Name>");
		_out.println(
			coTag()
				+ "<Model.Tag.TagId>"+_tag.tag_id()+"</Model.Tag.TagId>");
		_out.println(beTag() + "<Model.Tag.Values>");
		_out.println(
			coTag()
				+ "<XMI.any xmi.type=\"string\" xmi.name=\"mof_tag\">"
				+ _tag.values()[0].extract_string()
				+ "</XMI.any>");
		_out.println(enTag() + "</Model.Tag.Values>");
		_out.println(beTag() + "<Model.Tag.Elements>");
		_out.println(
			coTag()
				+ "<Model.Package xmi.idref=\"id_"
				+ _tag.container().ref_mof_id()
				+ "\"/>");
		_out.println(enTag() + "</Model.Tag.Elements>");
		_out.println(enTag() + "</Model.Tag>");
		}
	}

	public  void packageModuleTemplate(
		org.omg.mof.Model.Package _package)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds,
			org.omg.mof.Reflective.NotSet {
		//debut("PackageModuleTemplate", _package.name());
		if (_package
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			//Entte du fichier XML de sortie
			_out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			_out.println(
				"<!DOCTYPE Model SYSTEM \"http://www-src.lip6.fr/homepages/Salim.Bouzitouna/mof1.dtd\">");
			_out.println(
				"<!--DOCTYPE Model SYSTEM \"file:///D:/users/salim/execution/source/mof1.dtd\"-->");
			_out.println(beTag() + "<Model>");

			//le Package
			String _name1 = _package.name();
			String _annotation = _package.annotation().trim();
			org.omg.mof.Model.VisibilityKind _visibility =
				_package.visibility();
			boolean _abstract = _package.is_abstract();
			boolean _leaf = _package.is_leaf();
			boolean _root = _package.is_root();

			//gnrer de l'XML correpondant
			_out.println(
				beTag()
					+ "<Model.Package xmi.id=\"id_"
					+ _package.ref_mof_id()
					+ "\">");
			_out.println(
				coTag()
					+ "<Model.ModelElement.Name>"
					+ _name1
					+ "</Model.ModelElement.Name>");
			if (!_annotation.equalsIgnoreCase(""))
				_out.println(
					coTag()
						+ "<Model.ModelElement.Annotation>"
						+ _annotation
						+ "</Model.ModelElement.Annotation>");
			if (_visibility
				.equals(org.omg.mof.Model.VisibilityKind.private_vis))
				_out.println(
					coTag()
						+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
			else if (
				_visibility.equals(
					org.omg.mof.Model.VisibilityKind.protected_vis))
				_out.println(
					coTag()
						+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
			if (_leaf)
				_out.println(
					coTag()
						+ "<Model.GeneralizableElement.IsLeaf xmi.value=\"true\"/>");
			if (_root)
				_out.println(
					coTag()
						+ "<Model.GeneralizableElement.IsRoot xmi.value=\"true\"/>");
			if (_abstract)
				_out.println(
					coTag()
						+ "<Model.GeneralizableElement.IsAbstract xmi.value=\"true\"/>");

			//le contenu
			_out.println(beTag() + "<Model.Namespace.Contents>");

			// claculer le contenu
			org.omg.mof.Model.ModelElement[] _contents = _package.contents();
			java.util.Vector _datatypes = new java.util.Vector();
			java.util.Vector _packages = new java.util.Vector();
			java.util.Vector _classes = new java.util.Vector();
			java.util.Vector _associations = new java.util.Vector();
			java.util.Vector _exceptions = new java.util.Vector();
			java.util.Vector _constraints = new java.util.Vector();
			java.util.Vector _constants = new java.util.Vector();
			java.util.Vector _tags = new java.util.Vector();
			for (int i = 0; i < _contents.length; i++) {
				if (_contents[i]._is_a(org.omg.mof.Model.ClassHelper.id()))
					_classes.addElement(
						org.omg.mof.Model.ClassHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.PackageHelper.id()))
					_packages.addElement(
						org.omg.mof.Model.PackageHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.DataTypeHelper.id()))
					_datatypes.addElement(
						org.omg.mof.Model.DataTypeHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.MofExceptionHelper.id()))
					_exceptions.addElement(
						org.omg.mof.Model.MofExceptionHelper.narrow(
							_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.AssociationHelper.id()))
					_associations.addElement(
						org.omg.mof.Model.AssociationHelper.narrow(
							_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.ConstraintHelper.id()))
					_constraints.addElement(
						org.omg.mof.Model.ConstraintHelper.narrow(
							_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.ConstantHelper.id()))
					_constants.addElement(
						org.omg.mof.Model.ConstantHelper.narrow(_contents[i]));
				else if (_contents[i]._is_a(org.omg.mof.Model.TagHelper.id()))
					_tags.addElement(
						org.omg.mof.Model.TagHelper.narrow(_contents[i]));
			}

			java.util.Vector _classes_ordered = new java.util.Vector();
			while (_classes.size() != 0) {
				org.omg.mof.Model.Class _courant = null;
				for (int i = 0; i < _classes.size(); i++) {
					_courant = (org.omg.mof.Model.Class) _classes.elementAt(i);
					org.omg.mof.Model.GeneralizableElement[] _supertypes =
						_courant.supertypes();
					boolean _is_top = true;
					for (int j = 0; j < _supertypes.length; j++) {
						if (Helper.contains(_classes, _supertypes[j]))
							_is_top = false;
					}
					if (_is_top) {
						_classes_ordered.addElement(_courant);
						_classes.removeElement(_courant);
					}
				}
			}

			// rcuprer le contenu des classes pour minimiser les appels CORBA au cours du traitements du contenu de ces classeses
			for (int i = 0; i < _classes_ordered.size(); i++)
				helper.allContentsOfClasses(
					(org.omg.mof.Model.Class) _classes_ordered.elementAt(i));

			for (int i = 0; i < _constants.size(); i++)
				constantTemplate(
					(org.omg.mof.Model.Constant) _constants.elementAt(i));

			for (int i = 0; i < _packages.size(); i++)
				packageModuleTemplate(
					(org.omg.mof.Model.Package) _packages.elementAt(i));

			for (int i = 0; i < _datatypes.size(); i++)
				dataTypeTemplate(
					(org.omg.mof.Model.DataType) _datatypes.elementAt(i));

			for (int i = 0; i < _exceptions.size(); i++)
				exceptionTemplate(
					(org.omg.mof.Model.MofException) _exceptions.elementAt(i));

			for (int i = 0; i < _classes_ordered.size(); i++)
				classTemplate(
					(org.omg.mof.Model.Class) _classes_ordered.elementAt(i));

			for (int i = 0; i < _associations.size(); i++)
				associationTemplate(
					(org.omg.mof.Model.Association) _associations.elementAt(i));

			for (int i = 0; i < _constraints.size(); i++)
				constraintTemplate(
					(org.omg.mof.Model.Constraint) _constraints.elementAt(i));

			for (int i = 0; i < _tags.size(); i++)
				tagTemplate(
					(org.omg.mof.Model.Tag) _tags.elementAt(i));

			//fin
			_out.println(enTag() + "</Model.Namespace.Contents>");
			_out.println(enTag() + "</Model.Package>");
			_out.println(enTag() + "</Model>");
		} else {
		} //do_nothing
		//fin("PackageModuleTemplate", _package.name());
	}

	public  void dataTypeTemplate(org.omg.mof.Model.DataType _datatype)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		//debut("DataTypeTemplate", _datatype.name());
		//le DataType
		String _name = _datatype.name();
		String _annotation = _datatype.annotation().trim();
		org.omg.mof.Model.VisibilityKind _visibility = _datatype.visibility();
		boolean _abstract = _datatype.is_abstract();
		boolean _leaf = _datatype.is_leaf();
		boolean _root = _datatype.is_root();
		org.omg.CORBA.TypeCode _typecode = _datatype.type_code();

		//gnrer de l'XML correpondant
		_out.println(
			beTag()
				+ "<Model.DataType xmi.id=\"id_"
				+ _datatype.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (_visibility.equals(org.omg.mof.Model.VisibilityKind.private_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
		else if (
			_visibility.equals(org.omg.mof.Model.VisibilityKind.protected_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
		if (_leaf)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsLeaf xmi.value=\"true\"/>");
		if (_root)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsRoot xmi.value=\"true\"/>");
		if (_abstract)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsAbstract xmi.value=\"true\"/>");

		//traiter le type code
		_out.println(beTag() + "<Model.DataType.TypeCode>");

		typeCode2XML(_typecode);

		_out.println(enTag() + "</Model.DataType.TypeCode>");
		_out.println(enTag() + "</Model.DataType>");

		//fin("DataTypeTemplate", _datatype.name());
	}

	public  void typeCode2XML(org.omg.CORBA.TypeCode _typecode)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		_out.println(beTag() + "<XMI.CorbaTypeCode>");
		switch (_typecode.kind().value()) {
			case org.omg.CORBA.TCKind._tk_alias :
				{
					org.omg.CORBA.TypeCode _tc = _typecode.content_type();
					_out.println(
						beTag()
							+ "<XMI.CorbaTcAlias xmi.tcName=\""
							+ _tc.name()
							+ "\">");
					typeCode2XML(_tc);
					_out.println(enTag() + "</XMI.CorbaTcAlias>");

					break;
				}
			case org.omg.CORBA.TCKind._tk_struct :
				{
					_out.println(
						beTag()
							+ "<XMI.CorbaTcStruct xmi.tcName=\""
							+ _typecode.name()
							+ "\">");
					for (int i = 0; i < _typecode.member_count(); i++) {
						_out.println(
							beTag()
								+ "<XMI.CorbaTcField xmi.tcName=\""
								+ _typecode.member_name(i)
								+ "\">");
						typeCode2XML(_typecode.member_type(i));
						_out.println(enTag() + "</XMI.CorbaTcField>");
					}
					_out.println(enTag() + "</XMI.CorbaTcStruct>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_enum :
				{
					_out.println(
						beTag()
							+ "<XMI.CorbaTcEnum xmi.tcName=\""
							+ _typecode.name()
							+ "\">");
					_out.print(coTag() + "<XMI.CorbaTcEnumLabel xmi.tcName=\"");
					for (int i = 0; i < _typecode.member_count(); i++) {
						_out.print(_typecode.member_name(i));
						if (!(i == (_typecode.member_count() - 1)))
							_out.print("| ");
					}
					_out.println("\"/>");
					_out.println(enTag() + "</XMI.CorbaTcEnum>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_sequence :
				{
					org.omg.CORBA.TypeCode _tc = _typecode.content_type();
					_out.println(
						beTag()
							+ "<XMI.CorbaTcSequence xmi.tcLength=\""
							+ String.valueOf(_typecode.length())
							+ "\">");
					typeCode2XML(_tc);
					_out.println(enTag() + "</XMI.CorbaTcSequence>");
					break;
				}
			default :
				typeCode2BaseType(_typecode);
		}
		_out.println(enTag() + "</XMI.CorbaTypeCode>");
	}
	//
	//
	public  void typeCode2BaseType(org.omg.CORBA.TypeCode _typecode)
		throws org.omg.CORBA.TypeCodePackage.BadKind {
		switch (_typecode.kind().value()) {
			case org.omg.CORBA.TCKind._tk_boolean :
				{
					_out.println(coTag() + "<XMI.CorbaTcBoolean/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_octet :
				{
					_out.println(coTag() + "<XMI.CorbaTcOctet/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_char :
				{
					_out.println(coTag() + "<XMI.CorbaTcChar/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_wchar :
				{
					_out.println(coTag() + "<XMI.CorbaTcWchar/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_short :
				{
					_out.println(coTag() + "<XMI.CorbaTcShort/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_ushort :
				{
					_out.println(coTag() + "<XMI.CorbaTcUshort/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_long :
				{
					_out.println(coTag() + "<XMI.CorbaTcLong/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_ulong :
				{
					_out.println(coTag() + "<XMI.CorbaTcUlong/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_longlong :
				{
					_out.println(coTag() + "<XMI.CorbaTcLongLong/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_ulonglong :
				{
					_out.println(coTag() + "<XMI.CorbaTcULongLong/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_double :
				{
					_out.println(coTag() + "<XMI.CorbaTcDouble/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_float :
				{
					_out.println(coTag() + "<XMI.CorbaTcFloat/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_string :
				{
					int _length = _typecode.length();
					if (_length == 0)
						_out.println(
							coTag() + "<XMI.CorbaTcString xmi.tcLength=\"\"/>");
					else
						_out.println(
							coTag()
								+ "<XMI.CorbaTcString xmi.tcLength=\""
								+ _length
								+ "\"/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_wstring :
				{
					_out.println(coTag() + "<XMI.CorbaTcWstring/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_TypeCode :
				{
					_out.println(coTag() + "<XMI.CorbaTcTypeCode/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_any :
				{
					_out.println(coTag() + "<XMI.CorbaTcAny/>");
					break;
				}
			case org.omg.CORBA.TCKind._tk_objref :
				{
					_out.println(coTag() + "<XMI.CorbaTcObject/>");
					break;
				}
			default :
				throw new org.omg.CORBA.TypeCodePackage.BadKind();
		}
	}

	public  void exceptionTemplate(
		org.omg.mof.Model.MofException _exception)
		throws org.omg.mof.Reflective.MofError {
		//debut("ExceptionTemplate", _exception.name());
		//l'exception
		String _name = _exception.name();
		String _annotation = _exception.annotation();
		org.omg.mof.Model.VisibilityKind _visibility = _exception.visibility();
		org.omg.mof.Model.ScopeKind _scope = _exception.scope();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.MofException xmi.id=\"id_"
				+ _exception.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (_visibility.equals(org.omg.mof.Model.VisibilityKind.private_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
		else if (
			_visibility.equals(org.omg.mof.Model.VisibilityKind.protected_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
		if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level))
			_out.println(
				coTag()
					+ "<Model.Feature.Scope xmi.value=\"classifier_level\"/>");
		_out.println(enTag() + "</MofException>");
		//fin("ExceptionTemplate", _exception.name());
	}

	//les classes
	public  void classTemplate(org.omg.mof.Model.Class _class)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		//debut("ClassTemplate", _class.name());

		//les caractristiques de la classes
		String _name1 = _class.name();
		String _annotation = _class.annotation().trim();
		org.omg.mof.Model.VisibilityKind _visibility = _class.visibility();
		boolean _abstract = _class.is_abstract();
		boolean _leaf = _class.is_leaf();
		boolean _root = _class.is_root();
		boolean _singleton = _class.is_singleton();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.Class xmi.id=\"id_"
				+ _class.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name1
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (_visibility.equals(org.omg.mof.Model.VisibilityKind.private_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
		else if (
			_visibility.equals(org.omg.mof.Model.VisibilityKind.protected_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
		if (_leaf)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsLeaf xmi.value=\"true\"/>");
		if (_root)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsRoot xmi.value=\"true\"/>");
		if (_abstract)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsAbstract xmi.value=\"true\"/>");
		if (_singleton)
			_out.println(
				coTag() + "<Model.Class.IsSingleton xmi.value=\"true\"/>");

		//gnrer les tags du super classes
		org.omg.mof.Model.GeneralizableElement[] _supertypes =
			_class.supertypes();
		for (int i = 0; i < _supertypes.length; i++) {
			_out.println(beTag() + "<Model.GeneralizableElement.Supertypes>");
			_out.println(
				coTag()
					+ "<Model.Class xmi.idref=\"id_"
					+ _supertypes[i].ref_mof_id()
					+ "\"/>");
			_out.println(enTag() + "</Model.GeneralizableElement.Supertypes>");
		}

		//le contenu
		org.omg.mof.Model.ModelElement[] _contents = _class.contents();
		if (_contents.length > 0) {
			_out.println(beTag() + "<Model.Namespace.Contents>");

			//Calcul des reference et des attributs et des opration d'une classes
			java.util.Vector _datatypes = new java.util.Vector();
			java.util.Vector _attributes = new java.util.Vector();
			java.util.Vector _references = new java.util.Vector();
			java.util.Vector _operations = new java.util.Vector();
			java.util.Vector _constants = new java.util.Vector();

			for (int i = 0; i < _contents.length; i++) {
				if (_contents[i]._is_a(org.omg.mof.Model.ConstantHelper.id()))
					_constants.addElement(
						org.omg.mof.Model.ConstantHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.DataTypeHelper.id()))
					_datatypes.addElement(
						org.omg.mof.Model.DataTypeHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.MofAttributeHelper.id()))
					_attributes.addElement(
						org.omg.mof.Model.MofAttributeHelper.narrow(
							_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.ReferenceHelper.id()))
					_references.addElement(
						org.omg.mof.Model.ReferenceHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.OperationHelper.id()))
					_operations.addElement(
						org.omg.mof.Model.OperationHelper.narrow(_contents[i]));
			}

			for (int i = 0; i < _constants.size(); i++)
				constantTemplate(
					(org.omg.mof.Model.Constant) _constants.elementAt(i));

			for (int i = 0; i < _datatypes.size(); i++)
				dataTypeTemplate(
					(org.omg.mof.Model.DataType) _datatypes.elementAt(i));

			for (int i = 0; i < _attributes.size(); i++)
				attributeTemplate(
					(org.omg.mof.Model.MofAttribute) _attributes.elementAt(i));

			for (int i = 0; i < _references.size(); i++)
				referenceTemplate(
					(org.omg.mof.Model.Reference) _references.elementAt(i));

			for (int i = 0; i < _operations.size(); i++)
				operationTemplate(
					(org.omg.mof.Model.Operation) _operations.elementAt(i));

			_out.println(enTag() + "</Model.Namespace.Contents>");
		}
		_out.println(enTag() + "</Model.Class>");

		//fin("ClassTemplate", _class.name());
	}

	public  void associationTemplate(
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.MofError {

		//debut("AssociationTemplate", _association.name());
		//Association
		String _name1 = _association.name();
		String _annotation = _association.annotation().trim();
		org.omg.mof.Model.VisibilityKind _visibility =
			_association.visibility();
		boolean _abstract = _association.is_abstract();
		boolean _leaf = _association.is_leaf();
		boolean _root = _association.is_root();
		boolean _is_derived = _association.is_derived();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.Association xmi.id=\"id_"
				+ _association.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name1
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (_visibility.equals(org.omg.mof.Model.VisibilityKind.private_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
		else if (
			_visibility.equals(org.omg.mof.Model.VisibilityKind.protected_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
		if (_leaf)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsLeaf xmi.value=\"true\"/>");
		if (_root)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsRoot xmi.value=\"true\"/>");
		if (_abstract)
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.IsAbstract xmi.value=\"true\"/>");
		if (_is_derived)
			_out.println(
				coTag() + "<Model.Association.IsDerived xmi.value=\"true\"/>");

		//les associations Ens
		org.omg.mof.Model.ModelElement[] _contents = _association.contents();
		if (_contents.length > 0) {
			_out.println(beTag() + "<Model.Namespace.Contents>");
			org.omg.mof.Model.AssociationEnd[] _ends =
				associationEnds(_association);
			associationEndTemplate(_ends[0]);
			associationEndTemplate(_ends[1]);
			_out.println(enTag() + "</Model.Namespace.Contents>");
		}

		_out.println(enTag() + "</Model.Association>");
		//fin("AssociationTemplate", _association.name());
	}

	public  org.omg.mof.Model.AssociationEnd[] associationEnds(
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.MofError {
		//debut("AssociationEnd of", _association.name());
		org.omg.mof.Model.AssociationEnd[] _ass =
			new org.omg.mof.Model.AssociationEnd[2];
		org.omg.mof.Model.ModelElement[] _cont = _association.contents();
		for (int i = 0; i < _cont.length; i++) {
			if (_cont[i]._is_a(org.omg.mof.Model.AssociationEndHelper.id()))
				_ass[i] =
					(org.omg.mof.Model.AssociationEndHelper.narrow(_cont[i]));
		}
		//fin("AssociationEnd of",_association.name());
		return _ass;

	}

	public  void associationEndTemplate(
		org.omg.mof.Model.AssociationEnd _association_end)
		throws org.omg.mof.Reflective.MofError {
		//debut("AssociationEndTemplate", _reference.name());
		//Association
		String _name = _association_end.name();
		String _annotation = _association_end.annotation();
		org.omg.mof.Model.AggregationKind _aggregation =
			_association_end.aggregation();
		org.omg.mof.Model.MultiplicityType _multiplicity =
			_association_end.multiplicity();
		// la multiplicit
		int _upper = _multiplicity.upper;
		int _lower = _multiplicity.lower;
		boolean _is_ordered = _multiplicity.isOrdered;
		boolean _is_unique = _multiplicity.isUnique;

		boolean _is_navigable = _association_end.is_navigable();
		boolean _is_changeable = _association_end.is_changeable();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.AssociationEnd  xmi.id=\"id_"
				+ _association_end.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (!_is_navigable)
			_out.println(
				coTag()
					+ "<Model.AssociationEnd.IsNavigable xmi.value=\"false\"/>");
		if (_aggregation.equals(org.omg.mof.Model.AggregationKind.composite))
			_out.println(
				coTag()
					+ "<Model.AssociationEnd.Aggregation xmi.value=\"composite\"/>");
		else if (_aggregation.equals(org.omg.mof.Model.AggregationKind.shared))
			_out.println(
				coTag()
					+ "<Model.AssociationEnd.Aggregation xmi.value=\"shared\"/>");
		if ((_is_ordered) || (_is_unique) || (_lower != 0) || (_upper != 1)) {
			_out.println(beTag() + "<Model.AssociationEnd.Multiplicity>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_ordered)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_unique)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_lower)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_upper)
					+ "</XMI.field>");
			_out.println(enTag() + "</Model.AssociationEnd.Multiplicity>");
		}
		if (!_is_changeable)
			_out.println(
				coTag()
					+ "<Model.AssociationEnd.IsChangeable xmi.value=\"false\"/>");
		//le type de l'attribut
		_out.println(beTag() + "<Model.TypedElement.Type>");
		_out.println(
			coTag()
				+ "<Model.DataType xmi.idref=\"id_"
				+ _association_end.type().ref_mof_id()
				+ "\"/>");
		_out.println(enTag() + "</Model.TypedElement.Type>");

		_out.println(enTag() + "</Model.AssociationEnd>");
		//fin("AssociationEndTemplate", _association_end.name());
	}

	public  void constraintTemplate(
		org.omg.mof.Model.Constraint _constraint)
		throws org.omg.mof.Reflective.MofError {
		//debut("ConstraintTemplate", _constraint.name());
		_out.println("\tconst string " + Helper.format3(_constraint.name()));
		//fin("ConstantTemplate", _constraint.name());
	}

	//Constant 
	public  void constantTemplate(org.omg.mof.Model.Constant _constant)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		//debut("ConstantTemplate", _constant.name());

		//constant
		String _name = _constant.name();
		String _annotation = _constant.annotation();
		org.omg.CORBA.Any _value = _constant.value();
		org.omg.mof.Model.Classifier _type = _constant.type();

		_out.println(beTag() + "<Model.Constant>");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		_out.println(beTag() + "<Model.Constant.Value>");
		_out.println(
			coTag()
				+ "<XMI.any xmi.type=\""
				+ _constant.type().name()
				+ "\" xmi.name=\""
				+ _constant.name()
				+ "\">"
				+ helper.constantValue(_constant.value())
				+ "</XMI.any>");

		_out.println(enTag() + "</Model.Constant.Value>");
		_out.println(beTag() + "<Model.TypedElement.Type>");
		_out.println(
			coTag()
				+ "<Model.DataType xmi.idref=\"id_"
				+ _constant.type().ref_mof_id()
				+ "\"/>");
		_out.println(enTag() + "</Model.TypedElement.Type>");
		_out.println(enTag() + "</Model.Constant>");
		//fin("ConstantTemplate", _constant.name());
	}

	// Attribute
	public  void attributeTemplate(
		org.omg.mof.Model.MofAttribute _attribute)
		throws org.omg.mof.Reflective.MofError {
		//debut("AttributeTemplate", _attribute.name());

		//Attribute
		String _name = _attribute.name();
		String _annotation = _attribute.annotation();
		org.omg.mof.Model.VisibilityKind _visibility = _attribute.visibility();
		org.omg.mof.Model.ScopeKind _scope = _attribute.scope();
		org.omg.mof.Model.MultiplicityType _multiplicity =
			_attribute.multiplicity();
		// la multipliciy
		int _upper = _multiplicity.upper;
		int _lower = _multiplicity.lower;
		boolean _is_ordered = _multiplicity.isOrdered;
		boolean _is_unique = _multiplicity.isUnique;

		boolean _is_changeable = _attribute.is_changeable();
		boolean _is_derived = _attribute.is_derived();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.MofAttribute xmi.id=\"id_"
				+ _attribute.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (_visibility.equals(org.omg.mof.Model.VisibilityKind.private_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
		else if (
			_visibility.equals(org.omg.mof.Model.VisibilityKind.protected_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
		if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level))
			_out.println(
				coTag()
					+ "<Model.Feature.Scope xmi.value=\"classifier_level\"/>");
		if ((_is_ordered) || (_is_unique) || (_lower != 0) || (_upper != 1)) {
			_out.println(beTag() + "<Model.StructuralFeature.Multiplicity>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_ordered)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_unique)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_lower)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_upper)
					+ "</XMI.field>");
			_out.println(enTag() + "</Model.StructuralFeature.Multiplicity>");
		}
		if (!_is_changeable)
			_out.println(
				coTag()
					+ "<Model.StructuralFeature.IsChangeable xmi.value=\"false\"/>");
		if (_is_derived)
			_out.println(
				coTag() + "<Model.MofAttribute.IsDerived xmi.value=\"true\"/>");

		//le type de l'attribut
		_out.println(beTag() + "<Model.TypedElement.Type>");
		_out.println(
			coTag()
				+ "<Model.DataType xmi.idref=\"id_"
				+ _attribute.type().ref_mof_id()
				+ "\"/>");
		_out.println(enTag() + "</Model.TypedElement.Type>");

		_out.println(enTag() + "</Model.MofAttribute>");

		//fin("AttributeTemplate", _attribute.name());
	}

	public  void operationTemplate(
		org.omg.mof.Model.Operation _operation)
		throws org.omg.mof.Reflective.MofError {

		//debut("operationTemplate", _operation.name());
		//operaion
		String _name = _operation.name();
		String _annotation = _operation.annotation();
		org.omg.mof.Model.VisibilityKind _visibility = _operation.visibility();
		org.omg.mof.Model.ScopeKind _scope = _operation.scope();
		boolean _is_query = _operation.is_query();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.Operation xmi.id=\"id_"
				+ _operation.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (_visibility.equals(org.omg.mof.Model.VisibilityKind.private_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
		else if (
			_visibility.equals(org.omg.mof.Model.VisibilityKind.protected_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
		if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level))
			_out.println(
				coTag()
					+ "<Model.Feature.Scope xmi.value=\"classifier_level\"/>");
		if (!_is_query)
			_out.println(
				coTag() + "<Model.Operation.IsQuery xmi.value=\"false\"/>");

		//le contenu de l'opration
		org.omg.mof.Model.ModelElement[] _contents = _operation.contents();
		if (_contents.length > 0) {
			_out.println(beTag() + "<Model.Namespace.Contents>");

			//Calcul des reference et des attributs et des opration d'une classes
			java.util.Vector _parameters = new java.util.Vector();
			java.util.Vector _exceptions = new java.util.Vector();
			for (int i = 0; i < _contents.length; i++) {
				if (_contents[i]._is_a(org.omg.mof.Model.ParameterHelper.id()))
					_parameters.addElement(
						org.omg.mof.Model.ParameterHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.MofExceptionHelper.id()))
					_exceptions.addElement(
						org.omg.mof.Model.MofExceptionHelper.narrow(
							_contents[i]));
			}

			for (int i = 0; i < _parameters.size(); i++)
				parameterTemplate(
					(org.omg.mof.Model.Parameter) _parameters.elementAt(i));

			for (int i = 0; i < _exceptions.size(); i++)
				exceptionTemplate(
					(org.omg.mof.Model.MofException) _exceptions.elementAt(i));

			_out.println(enTag() + "</Model.Namespace.Contents>");
		}

		_out.println(enTag() + "</Model.Operation>");
		//fin("operationTemplate", _operation.name());
	}

	public  void parameterTemplate(
		org.omg.mof.Model.Parameter _parameter)
		throws org.omg.mof.Reflective.MofError {
		//debut("ParameterTemplate", _parameter.name());

		//paramtre
		String _name = _parameter.name();
		String _annotation = _parameter.annotation();
		org.omg.mof.Model.MultiplicityType _multiplicity =
			_parameter.multiplicity();
		// la multipliciy
		int _upper = _multiplicity.upper;
		int _lower = _multiplicity.lower;
		boolean _is_ordered = _multiplicity.isOrdered;
		boolean _is_unique = _multiplicity.isUnique;

		org.omg.mof.Model.DirectionKind _direction = _parameter.direction();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.Parameter xmi.id=\"id_"
				+ _parameter.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if ((_is_ordered) || (_is_unique) || (_lower != 0) || (_upper != 1)) {
			_out.println(beTag() + "<Model.Parameter.Multiplicity>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_ordered)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_unique)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_lower)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_upper)
					+ "</XMI.field>");
			_out.println(enTag() + "</Model.Parameter.Multiplicity>");
		}
		if (_direction.equals(org.omg.mof.Model.DirectionKind.out_dir))
			_out.println(
				coTag() + "<Model.Parameter.Direction xmi.value=\"out_dir\"/>");
		else if (_direction.equals(org.omg.mof.Model.DirectionKind.inout_dir))
			_out.println(
				coTag()
					+ "<Model.Parameter.Direction xmi.value=\"inout_dir\"/>");
		else if (_direction.equals(org.omg.mof.Model.DirectionKind.return_dir))
			_out.println(
				coTag()
					+ "<Model.Parameter.Direction xmi.value=\"return_dir\"/>");

		//le type du paramtre
		_out.println(beTag() + "<Model.TypedElement.Type>");
		_out.println(
			coTag()
				+ "<Model.DataType xmi.idref=\"id_"
				+ _parameter.type().ref_mof_id()
				+ "\"/>");
		_out.println(enTag() + "</Model.TypedElement.Type>");
		_out.println(enTag() + "</Model.Parameter>");

		//fin("ParameterTemplate", _parameter.name());
	}

	public  void referenceTemplate(
		org.omg.mof.Model.Reference _reference)
		throws org.omg.mof.Reflective.MofError {
		//debut("ReferenceTemplate", _reference.name());
		//Rfrence
		String _name = _reference.name();
		String _annotation = _reference.annotation();
		org.omg.mof.Model.VisibilityKind _visibility = _reference.visibility();
		org.omg.mof.Model.ScopeKind _scope = _reference.scope();
		org.omg.mof.Model.MultiplicityType _multiplicity =
			_reference.multiplicity();
		// la multiplicit
		int _upper = _multiplicity.upper;
		int _lower = _multiplicity.lower;
		boolean _is_ordered = _multiplicity.isOrdered;
		boolean _is_unique = _multiplicity.isUnique;

		boolean _is_changeable = _reference.is_changeable();

		// calculer l'XML correspondant
		_out.println(
			beTag()
				+ "<Model.Reference xmi.id=\"id_"
				+ _reference.ref_mof_id()
				+ "\">");
		_out.println(
			coTag()
				+ "<Model.ModelElement.Name>"
				+ _name
				+ "</Model.ModelElement.Name>");
		if (!_annotation.equalsIgnoreCase(""))
			_out.println(
				coTag()
					+ "<Model.ModelElement.Annotation>"
					+ _annotation
					+ "</Model.ModelElement.Annotation>");
		if (_visibility.equals(org.omg.mof.Model.VisibilityKind.private_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"private_vis\"/>");
		else if (
			_visibility.equals(org.omg.mof.Model.VisibilityKind.protected_vis))
			_out.println(
				coTag()
					+ "<Model.GeneralizableElement.Visibility xmi.value=\"protected_vis\"/>");
		if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level))
			_out.println(
				coTag()
					+ "<Model.Feature.Scope xmi.value=\"classifier_level\"/>");
		if ((_is_ordered) || (_is_unique) || (_lower != 0) || (_upper != 1)) {
			_out.println(beTag() + "<Model.StructuralFeature.Multiplicity>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_ordered)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_is_unique)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_lower)
					+ "</XMI.field>");
			_out.println(
				coTag()
					+ "<XMI.field>"
					+ String.valueOf(_upper)
					+ "</XMI.field>");
			_out.println(enTag() + "</Model.StructuralFeature.Multiplicity>");
		}
		if (!_is_changeable)
			_out.println(
				coTag()
					+ "<Model.StructuralFeature.IsChangeable xmi.value=\"false\"/>");

		// Referenced End
		_out.println(beTag() + "<Model.Reference.ReferencedEnd>");
		_out.println(
			coTag()
				+ "<Model.AssociationEnd xmi.idref=\"id_"
				+ _reference.referenced_end().ref_mof_id()
				+ "\"/>");
		_out.println(enTag() + "</Model.Reference.ReferencedEnd>");
		_out.println(enTag() + "</Model.Reference>");
		//fin("ReferenceTemplate", _reference.name());
	}
}
