/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.io;

import org.w3c.dom.*;
import fr.lip6.src.modfact.util.*;

import java.io.InputStream;

import javax.xml.parsers.*;

public class Import {

	//Dclaration des Factory
	private org.omg.mof.Model.PackageClass _package_class;
	private org.omg.mof.Model.ClassClass _class_class;
	private org.omg.mof.Model.MofAttributeClass _attribute_class;
	private org.omg.mof.Model.ReferenceClass _reference_class;
	private org.omg.mof.Model.AssociationClass _association_class;
	private org.omg.mof.Model.AssociationEndClass _association_end_class;
	private org.omg.mof.Model.RefersTo _refers_to_class;
	private org.omg.mof.Model.Exposes _exposes_class;
	private org.omg.mof.Model.DataTypeClass _datatype_class;
	private org.omg.mof.Model.ConstantClass _constant_class;
	private org.omg.mof.Model.ConstraintClass _constraint_class;
	private org.omg.mof.Model.TagClass _tag_class;
	private org.omg.mof.Model.OperationClass _operation_class;
	private org.omg.mof.Model.ParameterClass _parameter_class;
	private org.omg.mof.Model.MofExceptionClass _exception_class;

	// Dclaration
	private org.omg.CORBA.ORB _orb;
	private org.w3c.dom.Element _document;

	// Hashtables pour typer  les attributs et les paramtre et rajouter les supertypes
	private java.util.Hashtable _types = new java.util.Hashtable();
	private java.util.Hashtable _elementHisType = new java.util.Hashtable();
	private java.util.Hashtable _elementHisSupertypes =
		new java.util.Hashtable();

	//Hashtables pour les tags
	private java.util.Hashtable _tags = new java.util.Hashtable();
	private java.util.Hashtable _elementHisTag = new java.util.Hashtable();

	// Hashtables pour les typer les rfrences et les lier aux associationEnd
	private java.util.Hashtable _OtherEnd = new java.util.Hashtable();
	private java.util.Hashtable _Id2End = new java.util.Hashtable();
	private java.util.Hashtable _referencedEndTable = new java.util.Hashtable();
	private java.util.Hashtable _ConstantValue = new java.util.Hashtable();

	// initialisation
	public void initiate(
		org.omg.mof.Model.ModelPackage _model_package,
		org.omg.CORBA.ORB orb)
		throws org.omg.mof.Reflective.MofError {

		//creation des Factory
		_package_class = _model_package.package_ref();
		_class_class = _model_package.class_ref();
		_attribute_class = _model_package.mof_attribute_ref();
		_reference_class = _model_package.reference_ref();
		_association_class = _model_package.association_ref();
		_association_end_class = _model_package.association_end_ref();
		_refers_to_class = _model_package.refers_to_ref();
		_exposes_class = _model_package.exposes_ref();
		_datatype_class = _model_package.data_type_ref();
		_constant_class = _model_package.constant_ref();
		_constraint_class = _model_package.constraint_ref();
		_tag_class = _model_package.tag_ref();
		_operation_class = _model_package.operation_ref();
		_parameter_class = _model_package.parameter_ref();
		_exception_class = _model_package.mof_exception_ref();
		_orb = orb;
	}

	public org.omg.mof.Model.Package parse(String _fichier)
		throws
			org.xml.sax.SAXException,
			javax.xml.parsers.ParserConfigurationException,
			java.io.FileNotFoundException,
			java.io.IOException,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {

		// le package
		org.omg.mof.Model.Package _package = null;

		javax.xml.parsers.DocumentBuilderFactory _factory =
			javax.xml.parsers.DocumentBuilderFactory.newInstance();
		javax.xml.parsers.DocumentBuilder _builder =
			_factory.newDocumentBuilder();

		// Charger le document
		java.io.FileInputStream _xml_input_file =
			new java.io.FileInputStream(_fichier);
		org.w3c.dom.Document doc = _builder.parse(_xml_input_file);

		// Parser le document
		org.w3c.dom.Element _model = doc.getDocumentElement();
		_document = _model;
		//enlever les espaces
		delSpaces(_model);

		//rcuprer le contenus
		org.w3c.dom.NodeList _contents = _model.getChildNodes();
		for (int i = 0; i < _contents.getLength(); i++) {
			org.w3c.dom.Element _element =
				(org.w3c.dom.Element) _contents.item(i);
			String _name = _element.getNodeName().trim();
			//la package
			if (_name.endsWith("Package")) {
				_package = packageTemplate(_element);
				//System.out.println("notre package est :"+  _package.name());
			}
		}
		return _package;
	}

	public org.omg.mof.Model.Package parse(InputStream _xml_input_file)
		throws
			org.xml.sax.SAXException,
			javax.xml.parsers.ParserConfigurationException,
			java.io.FileNotFoundException,
			java.io.IOException,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {

		// le package
		org.omg.mof.Model.Package _package = null;

		javax.xml.parsers.DocumentBuilderFactory _factory =
			javax.xml.parsers.DocumentBuilderFactory.newInstance();
		javax.xml.parsers.DocumentBuilder _builder =
			_factory.newDocumentBuilder();

		// Charger le document
		org.w3c.dom.Document doc = _builder.parse(_xml_input_file);

		// Parser le document
		org.w3c.dom.Element _model = doc.getDocumentElement();
		_document = _model;
		//enlever les espaces
		delSpaces(_model);

		//rcuprer le contenus
		org.w3c.dom.NodeList _contents = _model.getChildNodes();
		for (int i = 0; i < _contents.getLength(); i++) {
			org.w3c.dom.Element _element =
				(org.w3c.dom.Element) _contents.item(i);
			String _name = _element.getNodeName().trim();
			//la package
			if (_name.endsWith("Package")) {
				_package = packageTemplate(_element);
				//System.out.println("notre package est :"+  _package.name());
			}
		}
		return _package;
	}

	// traitement du package
	public org.omg.mof.Model.Package packageTemplate(
		org.w3c.dom.Element _package_element)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		//cration par dfault du package
		org.omg.mof.Model.Package _package =
			_package_class.create_package(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false);

		// rcuprer les valeurs du pckage
		org.w3c.dom.NodeList _fils = _package_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_package.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_package.set_annotation(
					_current.getFirstChild().getNodeValue());
			else if (_name.endsWith("Visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected_vis"))
					_package.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private_vis"))
					_package.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("IsAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_package.set_is_abstract(true);
			} else if (_name.endsWith("IsLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_package.set_is_leaf(true);
			} else if (_name.endsWith("IsRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_package.set_is_root(true);
			} else if (_name.endsWith("Contents")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("DataType"))
						dataTypeTemplate(_element, _package);
					else if (_element_name.endsWith("Association"))
						associationTemplate(_element, _package);
					else if (_element_name.endsWith("Class"))
						classTemplate(_element, _package);
					else if (_element_name.endsWith("Constant"))
						constantTemplate(_element, _package);
					else if (_element_name.endsWith("Tag")) {
						tagTemplate(_element, _package);
					}
				}
			}
		}

		// ranger le package dans la table des tags
		String _key = _package_element.getAttribute("xmi.id").trim();
		_elementHisTag.put(_key, _package);

		// mettre les types, les tags  et les AssociationsEnds pour les rfrences
		typing();
		associationEnds4Reference();
		putSupertypes();
		taggedElement();
		return _package;
	}

	//Traitement des classes
	public void classTemplate(
		org.w3c.dom.Element _class_element,
		org.omg.mof.Model.Namespace _container)
		throws org.omg.mof.Reflective.MofError {
		// rcuprer l'identificateur
		String _key = _class_element.getAttribute("xmi.id").trim();

		// cration d'une classe par dfault
		org.omg.mof.Model.Class _class =
			_class_class.create_class(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false,
				false);

		// rcuprer les valeurs de la classe
		org.w3c.dom.NodeList _fils = _class_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_class.set_name(_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_class.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected_vis"))
					_class.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private_vis"))
					_class.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("IsAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_class.set_is_abstract(true);
			} else if (_name.endsWith("IsLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_class.set_is_leaf(true);
			} else if (_name.endsWith("IsRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_class.set_is_root(true);
			} else if (_name.endsWith("IsSingleton")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_class.set_is_singleton(true);
			} else if (_name.endsWith("Supertypes")) {
				java.util.Vector _supertypes_vector = new java.util.Vector();
				org.w3c.dom.NodeList _supertypes =
					_current.getElementsByTagName("Model.Class");
				for (int l = 0; l < _supertypes.getLength(); l++) {
					org.w3c.dom.Element _temp3 =
						(org.w3c.dom.Element) _supertypes.item(l);
					String _ref = _temp3.getAttribute("xmi.idref");
					// rajouter les classes
					_supertypes_vector.addElement(_ref);
				}
				_elementHisSupertypes.put(_class, _supertypes_vector);
			} else if (_name.endsWith("Contents")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("MofAttribute"))
						mofAttributeTemplate(_element, _class);
					else if (_element_name.endsWith("Reference"))
						referenceTemplate(_element, _class);
					else if (_element_name.endsWith("Operation"))
						operationTemplate(_element, _class);
					else if (_element_name.endsWith("DataType"))
						dataTypeTemplate(_element, _class);
					else if (_element_name.endsWith("Constant"))
						constantTemplate(_element, _class);
				}
			}
		}

		// container et contents
		_class.set_container(_container);
		_container.add_contents(_class);

		// ranger la classe dans la tables des types et ventuellement pour les tags
		_types.put(_key, _class);
		_elementHisTag.put(_key, _class);
	}

	// les attributs d'une classe
	public void mofAttributeTemplate(
		org.w3c.dom.Element _attribute_element,
		org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		// cration d'un attribut par dfault
		org.omg.mof.Model.MofAttribute _attribute =
			_attribute_class.create_mof_attribute(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				org.omg.mof.Model.ScopeKind.instance_level,
				new org.omg.mof.Model.MultiplicityType(0, 1, false, false),
				true,
				false);

		// rcuprer les valeurs de l'attribut
		org.w3c.dom.NodeList _fils = _attribute_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_attribute.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_attribute.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected_vis"))
					_attribute.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private_vis"))
					_attribute.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("Scope")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("classifier_level"))
					_attribute.set_scope(
						org.omg.mof.Model.ScopeKind.classifier_level);
			} else if (_name.endsWith("IsDerived")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_attribute.set_is_derived(true);
			} else if (_name.endsWith("Changeable")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("false"))
					_attribute.set_is_changeable(false);
			} else if (_name.endsWith("Multiplicity")) {
				// recuperer les valeurs de la multiplicity
				boolean _unique = false, _ordered = false;
				int _lower = 0, _upper = -1;
				org.w3c.dom.NodeList _multiplicity = _current.getChildNodes();
				for (int j = 0; j < _multiplicity.getLength(); j++) {
					org.w3c.dom.Element _item =
						(org.w3c.dom.Element) _multiplicity.item(j);
					if (j == 0) {
						if (_item
							.getFirstChild()
							.getNodeValue()
							.trim()
							.endsWith("true"))
							_ordered = true;
						else
							_ordered = false;
					} else if (j == 1) {
						if (_item
							.getFirstChild()
							.getNodeValue()
							.trim()
							.endsWith("true"))
							_unique = true;
						else
							_unique = false;
					} else if (j == 2) {
						_lower =
							Integer.parseInt(
								_item.getFirstChild().getNodeValue().trim());
					} else if (j == 3) {
						_upper =
							Integer.parseInt(
								_item.getFirstChild().getNodeValue().trim());
					}
				}
				// mettre  jour la multiplicity
				_attribute.set_multiplicity(
					new org.omg.mof.Model.MultiplicityType(
						_lower,
						_upper,
						_ordered,
						_unique));
			} else if (_name.endsWith("Type")) {
				// le type
				org.w3c.dom.Element _type =
					(org.w3c.dom.Element) _current.getFirstChild();
				String _ref = _type.getAttribute("xmi.idref").trim();
				_elementHisType.put(_attribute, _ref);

			}
		}
		_attribute.set_container(_class);
		_class.add_contents(_attribute);
	}

	// les rfrences d'une classe
	public void referenceTemplate(
		org.w3c.dom.Element _reference_element,
		org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		// cration d'une rfrence  par dfault
		org.omg.mof.Model.Reference _reference =
			_reference_class.create_reference(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				org.omg.mof.Model.ScopeKind.instance_level,
				new org.omg.mof.Model.MultiplicityType(0, 1, false, false),
				true);

		// rcuprer les valeurs de la rfrence
		org.w3c.dom.NodeList _fils = _reference_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_reference.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_reference.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected_vis"))
					_reference.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private_vis"))
					_reference.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("Scope")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("classifier_level"))
					_reference.set_scope(
						org.omg.mof.Model.ScopeKind.classifier_level);
			} else if (_name.endsWith("Changeable")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("false"))
					_reference.set_is_changeable(false);
			} else if (_name.endsWith("Multiplicity")) {
				// recuperer les valeurs de la multiplicity
				boolean _unique = false, _ordered = false;
				int _lower = 0, _upper = -1;
				org.w3c.dom.NodeList _multiplicity = _current.getChildNodes();
				for (int j = 0; j < _multiplicity.getLength(); j++) {
					org.w3c.dom.Element _item =
						(org.w3c.dom.Element) _multiplicity.item(j);
					if (j == 0) {
						if (_item
							.getFirstChild()
							.getNodeValue()
							.trim()
							.endsWith("true"))
							_ordered = true;
						else
							_ordered = false;
					} else if (j == 1) {
						if (_item
							.getFirstChild()
							.getNodeValue()
							.trim()
							.endsWith("true"))
							_unique = true;
						else
							_unique = false;
					} else if (j == 2) {
						_lower =
							Integer.parseInt(
								_item.getFirstChild().getNodeValue().trim());
					} else if (j == 3) {
						_upper =
							Integer.parseInt(
								_item.getFirstChild().getNodeValue().trim());
					}
				}

				// mettre  jour la multiplicity
				_reference.set_multiplicity(
					new org.omg.mof.Model.MultiplicityType(
						_lower,
						_upper,
						_ordered,
						_unique));
			} else if (_name.endsWith("Type")) {
				// le type
				//org.w3c.dom.Element _type = (org.w3c.dom.Element)_current.getFirstChild();
				//String _ref = _current.getAttribute("xmi.idref").trim();
			} else if (_name.endsWith("ReferencedEnd")) {
				// referenced
				org.w3c.dom.Element _referencedEnd =
					(org.w3c.dom.Element) _current.getFirstChild();
				org.w3c.dom.Element _end =
					(org.w3c.dom.Element) _current.getFirstChild();
				String _ref = _end.getAttribute("xmi.idref").trim();
				_referencedEndTable.put(_reference, _ref);
			}
		}
		//container et contained
		_reference.set_container(_class);
		_class.add_contents(_reference);
	}

	// les oprations d'une classe
	public void operationTemplate(
		org.w3c.dom.Element _operation_element,
		org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		// cration d'un attribut par dfault
		org.omg.mof.Model.Operation _operation =
			_operation_class.create_operation(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				org.omg.mof.Model.ScopeKind.instance_level,
				true);

		// rcuprer les valeurs de la rfrence
		org.w3c.dom.NodeList _fils = _operation_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_operation.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_operation.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected_vis"))
					_operation.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private_vis"))
					_operation.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("Scope")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("classifier_level"))
					_operation.set_scope(
						org.omg.mof.Model.ScopeKind.classifier_level);
			} else if (_name.endsWith("IsQuery")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("false"))
					_operation.set_is_query(false);
			} // traitement des paramtres
			else if (_name.endsWith("Contents")) {

				org.w3c.dom.NodeList _contents = _current.getChildNodes();

				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();

					if (_element_name.endsWith("Parameter")) {
						// cration d'un paramtre par dfault
						org.omg.mof.Model.Parameter _parameter =
							_parameter_class.create_parameter(
								"name",
								"",
								new org.omg.mof.Model.MultiplicityType(
									1,
									1,
									false,
									false),
								org.omg.mof.Model.DirectionKind.in_dir);

						// rcuprer les valeurs du paramtre
						org.w3c.dom.NodeList _temp1 = _element.getChildNodes();
						for (int k = 0; k < _temp1.getLength(); k++) {
							org.w3c.dom.Element _temp2 =
								(org.w3c.dom.Element) _temp1.item(k);
							String _name_p = _temp2.getNodeName().trim();
							if (_name_p.endsWith("Name"))
								_parameter.set_name(
									_temp2
										.getFirstChild()
										.getNodeValue()
										.trim());
							else if (_name_p.endsWith("Annotation"))
								_parameter.set_annotation(
									_temp2
										.getFirstChild()
										.getNodeValue()
										.trim());
							else if (_name_p.endsWith("Direction")) {
								String _direction =
									_temp2.getAttribute("xmi.value").trim();
								if (_direction.endsWith("out_dir"))
									_parameter.set_direction(
										org
											.omg
											.mof
											.Model
											.DirectionKind
											.out_dir);
								else if (_direction.endsWith("inout_dir"))
									_parameter.set_direction(
										org
											.omg
											.mof
											.Model
											.DirectionKind
											.inout_dir);
								else if (_direction.endsWith("return_dir"))
									_parameter.set_direction(
										org
											.omg
											.mof
											.Model
											.DirectionKind
											.return_dir);
							} else if (_name_p.endsWith("Multiplicity")) {
								// recuperer les valeurs de la multiplicity
								boolean _unique = false, _ordered = false;
								int _lower = 0, _upper = -1;
								org.w3c.dom.NodeList _multiplicity =
									_temp2.getChildNodes();
								for (int h = 0;
									h < _multiplicity.getLength();
									h++) {
									org.w3c.dom.Element _item =
										(
											org
												.w3c
												.dom
												.Element) _multiplicity
												.item(
											h);
									if (h == 0) {
										if (_item
											.getFirstChild()
											.getNodeValue()
											.trim()
											.endsWith("true"))
											_ordered = true;
										else
											_ordered = false;
									} else if (h == 1) {
										if (_item
											.getFirstChild()
											.getNodeValue()
											.trim()
											.endsWith("true"))
											_unique = true;
										else
											_unique = false;
									} else if (h == 2) {
										_lower =
											Integer.parseInt(
												_item
													.getFirstChild()
													.getNodeValue()
													.trim());
									} else if (h == 3) {
										_upper =
											Integer.parseInt(
												_item
													.getFirstChild()
													.getNodeValue()
													.trim());
									}
								}
								// mettre  jour la multiplicity
								_parameter.set_multiplicity(
									new org.omg.mof.Model.MultiplicityType(
										_lower,
										_upper,
										_ordered,
										_unique));
							} else if (_name_p.endsWith("Type")) {
								// le type
								org.w3c.dom.Element _type =
									(org.w3c.dom.Element) _temp2
										.getFirstChild();
								String _ref =
									_type.getAttribute("xmi.idref").trim();
								_elementHisType.put(_parameter, _ref);
							}
						}
						_operation.add_contents(_parameter);
						_parameter.set_container(_operation);
					} else if (_element_name.endsWith("MofException")) {
						// cration d'une exception  par dfault
						org.omg.mof.Model.MofException _exception =
							_exception_class.create_mof_exception(
								"name",
								"",
								org.omg.mof.Model.VisibilityKind.private_vis,
								org.omg.mof.Model.ScopeKind.instance_level);

						// rcuprer les valeurs de l'exception
						org.w3c.dom.NodeList _temp1 = _element.getChildNodes();
						for (int k = 0; k < _temp1.getLength(); k++) {
							org.w3c.dom.Element _temp2 =
								(org.w3c.dom.Element) _temp1.item(k);
							String _name_p = _temp2.getNodeName().trim();
							if (_name_p.endsWith("Name"))
								_exception.set_name(
									_current
										.getFirstChild()
										.getNodeValue()
										.trim());
							else if (_name_p.endsWith("Annotation"))
								_exception.set_annotation(
									_current
										.getFirstChild()
										.getNodeValue()
										.trim());
							else if (_name.endsWith("Visibility")) {
								String _visibility =
									_current.getAttribute("xmi.value").trim();
								if (_visibility.endsWith("protected_vis"))
									_exception.set_visibility(
										org
											.omg
											.mof
											.Model
											.VisibilityKind
											.protected_vis);
								else if (_visibility.endsWith("private_vis"))
									_exception.set_visibility(
										org
											.omg
											.mof
											.Model
											.VisibilityKind
											.private_vis);
							} else if (_name.endsWith("Scope")) {
								String _boolean =
									_current.getAttribute("xmi.value").trim();
								if (_boolean
									.trim()
									.endsWith("classifier_level"))
									_exception.set_scope(
										org
											.omg
											.mof
											.Model
											.ScopeKind
											.classifier_level);
							}
							_operation.add_contents(_exception);
							_exception.set_container(_operation);
						}
					}
				}
			}
		}
		_operation.set_container(_class);
		_class.add_contents(_operation);
	}

	//Traitement des oprations
	public void associationTemplate(
		org.w3c.dom.Element _association_element,
		org.omg.mof.Model.Namespace _container)
		throws org.omg.mof.Reflective.MofError {

		// cration d'une classe par dfault
		org.omg.mof.Model.Association _association =
			_association_class.create_association(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false,
				false);

		//Stocker les Id des associationEnds
		String[] _ends = new String[2];
		int k = 0;

		// rcuprer les valeurs de la classe
		org.w3c.dom.NodeList _fils = _association_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_association.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_association.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected_vis"))
					_association.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private_vis"))
					_association.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("IsAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_association.set_is_abstract(true);
			} else if (_name.endsWith("IsLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_association.set_is_leaf(true);
			} else if (_name.endsWith("IsRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_association.set_is_root(true);
			} else if (_name.endsWith("IsDerived")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_association.set_is_derived(true);
			} else if (_name.endsWith("Contents")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("AssociationEnd")) {
						associationEndTemplate(_element, _association);
						_ends[k] = _element.getAttribute("xmi.id").trim();
						k++;
					}
				}
			}
		}

		// container et contents
		_association.set_container(_container);
		_container.add_contents(_association);

		// rajouer les association pour otherends
		_OtherEnd.put(_ends[0], _ends[1]);
		_OtherEnd.put(_ends[1], _ends[0]);

		//rajouter l'association dans la table des tags
		String _key = _association_element.getAttribute("xmi.id").trim();
		_types.put(_key, _association);
	}

	// les associations ends d'une classe
	public void associationEndTemplate(
		org.w3c.dom.Element _end_element,
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.MofError {
		// cration de l'association end par dfault
		org.omg.mof.Model.AssociationEnd _association_end =
			_association_end_class.create_association_end(
				"name",
				"",
				true,
				org.omg.mof.Model.AggregationKind.none,
				new org.omg.mof.Model.MultiplicityType(0, 1, false, false),
				true);

		// rcuprer les valeurs de l'association end
		org.w3c.dom.NodeList _fils = _end_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_association_end.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_association_end.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Aggregation")) {
				String _aggregation = _current.getAttribute("xmi.value").trim();
				if (_aggregation.endsWith("shared"))
					_association_end.set_aggregation(
						org.omg.mof.Model.AggregationKind.shared);
				else if (_aggregation.endsWith("composite"))
					_association_end.set_aggregation(
						org.omg.mof.Model.AggregationKind.composite);
			} else if (_name.endsWith("IsNavigable")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("false"))
					_association_end.set_is_navigable(false);
			} else if (_name.endsWith("Changeable")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("false"))
					_association_end.set_is_changeable(false);
			} else if (_name.endsWith("Multiplicity")) {
				// recuperer les valeurs de la multiplicity
				boolean _unique = false, _ordered = false;
				int _lower = 0, _upper = -1;
				org.w3c.dom.NodeList _multiplicity = _current.getChildNodes();
				for (int j = 0; j < _multiplicity.getLength(); j++) {
					org.w3c.dom.Element _item =
						(org.w3c.dom.Element) _multiplicity.item(j);
					if (j == 0) {
						if (_item
							.getFirstChild()
							.getNodeValue()
							.trim()
							.endsWith("true"))
							_ordered = true;
						else
							_ordered = false;
					} else if (j == 1) {
						if (_item
							.getFirstChild()
							.getNodeValue()
							.trim()
							.endsWith("true"))
							_unique = true;
						else
							_unique = false;
					} else if (j == 2) {
						_lower =
							Integer.parseInt(
								_item.getFirstChild().getNodeValue().trim());
					} else if (j == 3) {
						_upper =
							Integer.parseInt(
								_item.getFirstChild().getNodeValue().trim());
					}
				}
				// anciennes definition de la multiplicit
				//		boolean _unique , _ordered ;
				//		int _lower, _upper ;
				//		String _multiplicity = _current.getFirstChild().getNodeValue();
				//		java.util.StringTokenizer _parties = new java.util.StringTokenizer(_multiplicity, ",");
				//		if(_parties.nextToken().trim().endsWith("true")) _ordered = true;
				//		else _ordered =false ;
				//		if(_parties.nextToken().trim().endsWith("true")) _unique = true ;
				//		else _unique = false ;
				//		_lower = Integer.parseInt(_parties.nextToken().trim());
				//	        _upper= Integer.parseInt(_parties.nextToken().trim());

				// mettre  jour la multiplicity
				_association_end.set_multiplicity(
					new org.omg.mof.Model.MultiplicityType(
						_lower,
						_upper,
						_ordered,
						_unique));
			} else if (_name.endsWith("Type")) {
				// le type
				org.w3c.dom.Element _type =
					(org.w3c.dom.Element) _current.getFirstChild();
				String _ref = _type.getAttribute("xmi.idref").trim();
				_elementHisType.put(_association_end, _ref);

			}
		}
		// stocker
		String _key = _end_element.getAttribute("xmi.id").trim();
		_Id2End.put(_key, _association_end);

		// contents et container
		_association_end.set_container(_association);
		_association.add_contents(_association_end);
	}

	//Traitement des Datatypes
	public void dataTypeTemplate(
		org.w3c.dom.Element _datatype_element,
		org.omg.mof.Model.Namespace _namespace)
		throws org.omg.mof.Reflective.MofError {

		// cration d'un DataType par dfault
		org.omg.mof.Model.DataType _datatype =
			_datatype_class.create_data_type(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false,
				_orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any));

		// rcuprer les valeurs de la classe
		org.w3c.dom.NodeList _fils = _datatype_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_datatype.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_datatype.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected_vis"))
					_datatype.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private_vis"))
					_datatype.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("IsAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_abstract(true);
			} else if (_name.endsWith("IsLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_leaf(true);
			} else if (_name.endsWith("IsRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_root(true);
			} else if (_name.endsWith("DataType.TypeCode")) {
				org.w3c.dom.Element _corba_typecode =
					(org.w3c.dom.Element) _current.getElementsByTagName(
						"XMI.CorbaTypeCode").item(
						0);

				org.w3c.dom.Element _element =
					(org.w3c.dom.Element) _corba_typecode.getChildNodes().item(
						0);

				//calcul du Repository ID
				String RepositoryID =
					"IDL:" + Helper.format1(_namespace.name());

				// clacul de _type code
				org.omg.CORBA.TypeCode _type_code =
					xml2TypeCode(_element, RepositoryID);
				_datatype.set_type_code(_type_code);
			}
		}

		// container et contents
		_datatype.set_container(_namespace);
		_namespace.add_contents(_datatype);

		// ranger la classe dans la tabkes des typeset eventuellement les tags
		String _key = _datatype_element.getAttribute("xmi.id").trim();
		_types.put(_key, _datatype);
		_elementHisTag.put(_key, _datatype);
	}

	//Traitement des constants
	public void constantTemplate(
		org.w3c.dom.Element _constant_element,
		org.omg.mof.Model.Namespace _namespace)
		throws org.omg.mof.Reflective.MofError {

		// cration d'un constant par dfault
		org.omg.mof.Model.Constant _constant =
			_constant_class.create_constant("name", "", _orb.create_any());
		//la valeur 
		String _id = _constant_element.getAttribute("xmi.id").trim();

		// rcuprer les valeurs de la constante
		org.w3c.dom.NodeList _fils = _constant_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_constant.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_constant.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Constant.Value")) {
				org.w3c.dom.Element _any =
					(org.w3c.dom.Element) _current.getFirstChild();
				String _value = _any.getLastChild().getNodeValue().trim();
				_ConstantValue.put(_constant, _value);

			} else if (_name.endsWith("Type")) {
				// le type
				org.w3c.dom.Element _type =
					(org.w3c.dom.Element) _current.getFirstChild();
				String _ref = _type.getAttribute("xmi.idref").trim();
				_elementHisType.put(_constant, _ref);
			}
		}
		_constant.set_container(_namespace);
		_namespace.add_contents(_constant);
	}

	// traitement du Tag
	public void tagTemplate(
		org.w3c.dom.Element _tag_element,
		org.omg.mof.Model.Namespace _namespace)
		throws org.omg.mof.Reflective.MofError {
		// cration d'une classe par dfault
		org.omg.CORBA.Any[] _any_t = new org.omg.CORBA.Any[1];
		org.omg.CORBA.Any _mof_tag = _orb.create_any();
		_mof_tag.insert_string("");
		_any_t[0] = _mof_tag;
		org.omg.mof.Model.Tag _tag =
			_tag_class.create_tag("name", "", "", _any_t);
		// rcuprer les valeurs de la classe
		org.w3c.dom.NodeList _fils = _tag_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Name"))
				_tag.set_name(_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_tag.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("TagId"))
				_tag.set_tag_id(_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Values")) {
				org.w3c.dom.Element _any_element =
					(org.w3c.dom.Element) _current.getElementsByTagName(
						"XMI.any").item(
						0);
				String _type = _any_element.getAttribute("xmi.type").trim();
				if (_type.endsWith("string")) {
					org.omg.CORBA.Any[] _any_tc = new org.omg.CORBA.Any[1];
					org.omg.CORBA.Any _mof_tag_c = _orb.create_any();
					_mof_tag_c.insert_string(
						_any_element.getFirstChild().getNodeValue().trim());
					_any_tc[0] = _mof_tag_c;
					_tag.set_values(_any_tc);
				}
			} else if (_name.endsWith("Elements")) {
				java.util.Vector _tagged_elements = new java.util.Vector();
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _key_element =
						_element.getAttribute("xmi.idref").trim();
					_tagged_elements.addElement(_key_element);
				}
				_tags.put(_tag, _tagged_elements);
			}
		}
		_tag.set_container(_namespace);
		_namespace.add_contents(_tag);
	}

	// passer de l'XML au Type code CORBA
	public org.omg.CORBA.TypeCode xml2TypeCode(
		org.w3c.dom.Element _element,
		String RepositoryID)
		throws org.omg.CORBA.BAD_TYPECODE {
		String _element_name = _element.getNodeName().trim();
		org.omg.CORBA.TypeCode _typecode = null;
		if (_element_name.startsWith("XMI.CorbaTcBoolean"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
		else if (_element_name.startsWith("XMI.CorbaTcOctet"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet);
		else if (_element_name.startsWith("XMI.CorbaTcChar"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_char);
		else if (_element_name.startsWith("XMI.CorbaTcWchar"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_wchar);
		else if (_element_name.startsWith("XMI.CorbaTcShort"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_short);
		else if (_element_name.startsWith("XMI.CorbaTcUshort"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ushort);
		else if (_element_name.startsWith("XMI.CorbaTcLong"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
		else if (_element_name.startsWith("XMI.CorbaTcUlong"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
		else if (_element_name.startsWith("XMI.CorbaTcLongLong"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
		else if (_element_name.startsWith("XMI.CorbaTcULongLong"))
			_typecode =
				_orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulonglong);
		else if (_element_name.startsWith("XMI.CorbaTcDouble"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_double);
		else if (_element_name.startsWith("XMI.CorbaTcFloat"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_float);
		else if (_element_name.startsWith("XMI.CorbaTcTypeCode"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_TypeCode);
		else if (_element_name.startsWith("XMI.CorbaTcAny"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any);
		else if (_element_name.startsWith("XMI.CorbaTcString")) {
			String _bound_value = _element.getAttribute("xmi.tcLength").trim();
			if (_bound_value.compareTo("") == 0)
				_typecode =
					_orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
			else {
				int _bound = Integer.parseInt(_bound_value);
				_typecode = _orb.create_string_tc(_bound);
			}
		} else if (_element_name.startsWith("XMI.CorbaTcWstring")) {
			String _bound_value = _element.getAttribute("xmi.tcLength").trim();
			if (_bound_value.compareTo("") != 0)
				_typecode =
					_orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
			else {
				int _bound = Integer.parseInt(_bound_value);
				_typecode = _orb.create_string_tc(_bound);
			}
		} else if (_element_name.startsWith("XMI.CorbaTcStruct")) {
			
			// le nom de la structure
			String _name = _element.getAttribute("xmi.tcName").trim();
			String RepID = RepositoryID + "/" + _name + ":1.0";
			
			// ruprer les membres de la structure
			org.w3c.dom.NodeList _fields = _element.getChildNodes();
			java.util.Vector _struct_members = new java.util.Vector();
			for (int i = 0; i < _fields.getLength(); i++) {
				org.w3c.dom.Element _field =
					(org.w3c.dom.Element) _fields.item(i);
				String _tag = _field.getNodeName();
				if (_tag.endsWith("CorbaTcField")) {
					org.w3c.dom.Element _type_field =
						(org.w3c.dom.Element) _field.getElementsByTagName(
							"XMI.CorbaTypeCode").item(
							0);
					//  construire les membres de la structure
					org.omg.CORBA.StructMember _member =
						new org.omg.CORBA.StructMember();
					// nom
					String _field_name =
						_field.getAttribute("xmi.tcName").trim();
					_member.name = _field_name;
					// le type
					org.w3c.dom.Element _type_element =
						(org.w3c.dom.Element) _field.getElementsByTagName(
							"XMI.CorbaTypeCode").item(
							0);
					org.w3c.dom.Element _typecode_element =
						(org.w3c.dom.Element) _type_element.getFirstChild();
					org.omg.CORBA.TypeCode _field_typecode =
						xml2TypeCode(
							_typecode_element,
							RepID.substring(0, RepID.lastIndexOf(":")));
					_member.type = _field_typecode;
					//
					_struct_members.addElement(_member);
				}
			} //
			org.omg.CORBA.StructMember[] _members =
				new org.omg.CORBA.StructMember[_struct_members.size()];
			for (int j = 0; j < _struct_members.size(); j++)
				_members[j] =
					(org.omg.CORBA.StructMember) _struct_members.elementAt(j);
			_typecode = _orb.create_struct_tc(RepID, _name, _members);
		} else if (_element_name.startsWith("XMI.CorbaTcSequence")) {
			//longueur de la sequence
			String _bound_value = _element.getAttribute("xmi.tcLength").trim();
			int _bound = 0;
			if (_bound_value.compareTo("") != 0)
				_bound = Integer.parseInt(_bound_value);
			//recuprer le type de la sequence
			org.w3c.dom.Element _type_code =
				(org.w3c.dom.Element) _element.getElementsByTagName(
					"XMI.CorbaTypeCode").item(
					0);
			org.w3c.dom.Element _sequence_element =
				(org.w3c.dom.Element) _type_code.getFirstChild();
			// rcuprer le type code de la squence
			org.omg.CORBA.TypeCode _sequence_type =
				xml2TypeCode(_sequence_element, "");
			_typecode = _orb.create_sequence_tc(_bound, _sequence_type);
		} else if (_element_name.startsWith("XMI.CorbaTcEnum")) {
			// le nom de l'numration
			String _name = _element.getAttribute("xmi.tcName").trim();
			String RepID = RepositoryID + "/" + _name + ":1.0";
			// calculer les membres de l'numration
			java.util.Vector _members = new java.util.Vector();
			org.w3c.dom.Element _enum_label =
				(org.w3c.dom.Element) _element
					.getElementsByTagName("XMI.CorbaTcEnumLabel")
					.item(0);
			String _values = _enum_label.getAttribute("xmi.tcName").trim();
			java.util.StringTokenizer _parties =
				new java.util.StringTokenizer(_values, "|");
			while (_parties.hasMoreElements()) {
				_members.addElement(_parties.nextToken().trim());
			}

			String[] _enum_members = new String[_members.size()];
			for (int i = 0; i < _members.size(); i++)
				_enum_members[i] = (String) _members.elementAt(i);
			_typecode = _orb.create_enum_tc(RepID, _name, _enum_members);
		} else if (_element_name.startsWith("XMI.CorbaTcAlias")) {
			// le nom de l'numration
			String _name = _element.getAttribute("xmi.tcName").trim();
			String RepID = RepositoryID + "/" + _name + ":1.0";
			//recuprer le type de l'alias
			org.w3c.dom.Element _type_code =
				(org.w3c.dom.Element) _element.getElementsByTagName(
					"XMI.CorbaTypeCode").item(
					0);
			org.w3c.dom.Element _alias_element =
				(org.w3c.dom.Element) _type_code.getFirstChild();
			// rcuprer le type code d'origine
			org.omg.CORBA.TypeCode _original_type =
				xml2TypeCode(
					_alias_element,
					RepID.substring(0, RepID.lastIndexOf(":")));
			_typecode = _orb.create_alias_tc(RepID, _name, _original_type);
		}
		return _typecode;
	}

	// typer les paramtres et les attributs et les constant
	public void typing()
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _elementHisType.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.TypedElement _typed_element =
				(org.omg.mof.Model.TypedElement) _keys.nextElement();
			// trouver la cl dans la deuxime table
			String _key = ((String) _elementHisType.get(_typed_element)).trim();

			// trouve le classifier
			org.omg.mof.Model.Classifier _classifier =
				(org.omg.mof.Model.Classifier) _types.get(_key);

			// typer
			_typed_element.set_type(_classifier);

			// affecter la valeur des constant
			if (_typed_element._is_a(org.omg.mof.Model.ConstantHelper.id())) {
				org.omg.mof.Model.Constant _constant =
					org.omg.mof.Model.ConstantHelper.narrow(_typed_element);
				String _value = (String) _ConstantValue.get(_constant);
				putConstantValue(_constant, _value);

			}
		}
	}

	//mettre les valeurs des constants
	public void putConstantValue(
		org.omg.mof.Model.Constant _constant,
		String _value)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		org.omg.mof.Model.Classifier _classifier = _constant.type();
		if (_classifier._is_a(org.omg.mof.Model.DataTypeHelper.id())) {
			org.omg.mof.Model.DataType _datatype =
				org.omg.mof.Model.DataTypeHelper.narrow(_classifier);
			org.omg.CORBA.TypeCode _typecode = _datatype.type_code();
			org.omg.CORBA.Any _any = _orb.create_any();
			switch (_typecode.kind().value()) {
				case org.omg.CORBA.TCKind._tk_boolean :
					_any.insert_boolean(Boolean.valueOf(_value).booleanValue());
					break;
				case org.omg.CORBA.TCKind._tk_octet :

					_any.insert_octet(Byte.valueOf(_value).byteValue());
					break;
				case org.omg.CORBA.TCKind._tk_char :
					_any.insert_char(_value.charAt(0));
					break;
				case org.omg.CORBA.TCKind._tk_wchar :
					_any.insert_wchar(_value.charAt(0));
					break;

				case org.omg.CORBA.TCKind._tk_short :
					_any.insert_short(Short.valueOf(_value).shortValue());
					break;

				case org.omg.CORBA.TCKind._tk_ushort :
					_any.insert_ushort(Short.valueOf(_value).shortValue());
					break;

				case org.omg.CORBA.TCKind._tk_long :
					_any.insert_long(Integer.valueOf(_value).intValue());
					break;

				case org.omg.CORBA.TCKind._tk_ulong :
					_any.insert_ulong(Integer.valueOf(_value).intValue());
					break;

				case org.omg.CORBA.TCKind._tk_longlong :
					_any.insert_longlong(Long.valueOf(_value).longValue());
					break;

				case org.omg.CORBA.TCKind._tk_ulonglong :
					_any.insert_ulonglong(Long.valueOf(_value).longValue());
					break;

				case org.omg.CORBA.TCKind._tk_double :
					_any.insert_double(Double.valueOf(_value).doubleValue());
					break;

				case org.omg.CORBA.TCKind._tk_float :
					_any.insert_float(Float.valueOf(_value).floatValue());
					break;

				case org.omg.CORBA.TCKind._tk_string :
					_any.insert_string(_value.trim());
					break;

				case org.omg.CORBA.TCKind._tk_wstring :
					_any.insert_wstring(_value.trim());
					break;

				default :
					throw new org.omg.CORBA.TypeCodePackage.BadKind();
			}
			_constant.set_value(_any);
		}
	}

	//Mettre les supertypes  la fin
	private void putSupertypes() throws org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _elementHisSupertypes.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.Class _class =
				(org.omg.mof.Model.Class) _keys.nextElement();
			// trouver la cl dans la deuxime table
			java.util.Vector _supertypes =
				((java.util.Vector) _elementHisSupertypes.get(_class));
			for (int i = 0; i < _supertypes.size(); i++) {
				String _key = ((String) _supertypes.elementAt(i)).trim();
				org.omg.mof.Model.Class _element =
					(org.omg.mof.Model.Class) _types.get(_key);
				_class.add_supertypes(_element);
			}
		}
	}

	// affecter les tags aux lments
	public void taggedElement() throws org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _tags.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.Tag _tag =
				(org.omg.mof.Model.Tag) _keys.nextElement();
			// trouver la cl dans la deuxime table
			java.util.Vector _tagged_elements =
				(java.util.Vector) _tags.get(_tag);
			for (int i = 0; i < _tagged_elements.size(); i++) {
				String _key = ((String) _tagged_elements.elementAt(i)).trim();
				org.omg.mof.Model.ModelElement _element =
					(org.omg.mof.Model.ModelElement) _elementHisTag.get(_key);
				_tag.add_elements(_element);
			}
		}
	}

	// typage des rfrence et les lier aux associationsEnds corrrespondantes
	public void associationEnds4Reference()
		throws org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _referencedEndTable.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.Reference _reference =
				(org.omg.mof.Model.Reference) _keys.nextElement();
			String _refend_id = (String) _referencedEndTable.get(_reference);
			org.omg.mof.Model.AssociationEnd _ref_end =
				(org.omg.mof.Model.AssociationEnd) _Id2End.get(_refend_id);
			_reference.set_type(_ref_end.type());
			_reference.set_referenced_end(_ref_end);
			// Mettre exposedEnd
			String _expend_id = (String) _OtherEnd.get(_refend_id);
			org.omg.mof.Model.AssociationEnd _exp_end =
				(org.omg.mof.Model.AssociationEnd) _Id2End.get(_expend_id);
			_reference.set_exposed_end(_exp_end);
		}
	}

	// suprimer les noeuds qui contiennent du text vide
	public void delSpaces(org.w3c.dom.Node _node)
		throws
			org.xml.sax.SAXException,
			javax.xml.parsers.ParserConfigurationException,
			java.io.FileNotFoundException,
			java.io.IOException {

		org.w3c.dom.NodeList _fils = _node.getChildNodes();
		int i = 0;
		while (i < _fils.getLength()) {
			org.w3c.dom.Node _temp = _fils.item(i);
			if (_temp.getNodeType() == 3) {
				String _temp1 = _temp.getNodeValue();
				if (_temp1.trim().compareTo("") == 0)
					_node.removeChild(_temp);
				else
					i++;
			} else {
				delSpaces(_temp);
				i++;
			}
		}
	}
}