/*====================================================================

created on 14 aot 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class EmitterPortInstanceListImpl
extends LocalObject
implements EmitterPortInstanceList
{
  private Table _emitters; 
  
  public EmitterPortInstanceListImpl()
  {
    _emitters = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.EmitterPortInstanceListOperations#get_emitter_port_instance(java.lang.String)
   */
  public EmitterPortInstance 
  get_emitter_port_instance(String name) 
  throws InvalidName
  {
    EmitterPortInstance result = (EmitterPortInstance) _emitters.get(name);
    if(result == null)
      throw new InvalidName();
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.EmitterPortInstanceListOperations#get_named_emitter_port_instances(java.lang.String[])
   */
  public EmitterPortInstance[] 
  get_named_emitter_port_instances(String[] names) 
  throws InvalidName
  {
    EmitterPortInstance[] result = new EmitterPortInstance[names.length];

   // Iterate on all the connections.
  
   int i = 0;
   for(i=0;i<names.length;i++)
   {
     result[i] = (EmitterPortInstance)_emitters.get(names[i]);
     
     if(result[i] == null)
     {
       throw new InvalidName();
     }
    }
   
   return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.EmitterPortInstanceListOperations#get_all_emitter_port_instances()
   */
  public EmitterPortInstance[] 
  get_all_emitter_port_instances()
  {
    EmitterPortInstance[] result = new EmitterPortInstance[_emitters.size()];
  
     // Iterate on all the connections.
     int idx = 0;
     for(java.util.Enumeration enum = _emitters.elements(); enum.hasMoreElements(); )
     {
       EmitterPortInstance info = (EmitterPortInstance)enum.nextElement();
         result[idx++] = info;
     }
     return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.EmitterPortInstanceListOperations#add_emitter_port_instance(org.objectweb.ccm.Containers.MetaInformation.EmitterPortInstance)
   */
  public void add_emitter_port_instance(EmitterPortInstance cpi)
  {
    String key = cpi.type_reference().name() ;//+ cpi.toString().substring(cpi.toString().lastIndexOf("@"));
    _emitters.put(key,cpi);
    
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.EmitterPortInstanceListOperations#remove_emitter_port_instance(java.lang.String)
   */
  public void remove_emitter_port_instance(String name) 
  throws InvalidName
  {
    Object result = _emitters.remove(name);
    
    if (result == null) throw new InvalidName();
  }
}
