/*====================================================================

created on 14 aot 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class PublisherPortInstanceListImpl
extends LocalObject
implements PublisherPortInstanceList
{
  private Table _publishers; 
  
  public PublisherPortInstanceListImpl()
  {
    _publishers = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.PublisherPortInstanceListOperations#get_publisher_port_instance(java.lang.String)
   */
  public PublisherPortInstance 
  get_publisher_port_instance(String name) 
  throws InvalidName
  {
    PublisherPortInstance result = (PublisherPortInstance) _publishers.get(name);
    if(result == null)
      throw new InvalidName();
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.PublisherPortInstanceListOperations#get_named_publisher_port_instances(java.lang.String[])
   */
  public PublisherPortInstance[] 
  get_named_publisher_port_instances(String[] names) 
  throws InvalidName
  {
    PublisherPortInstance[] result = new PublisherPortInstance[names.length];

   // Iterate on all the connections.
  
   int i = 0;
   for(i=0;i<names.length;i++)
   {
     result[i] = (PublisherPortInstance)_publishers.get(names[i]);
     
     if(result[i] == null)
     {
       throw new InvalidName();
     }
    }
   
   return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.PublisherPortInstanceListOperations#get_all_publisher_port_instances()
   */
  public PublisherPortInstance[] 
  get_all_publisher_port_instances()
  {
    PublisherPortInstance[] result = new PublisherPortInstance[_publishers.size()];
  
     // Iterate on all the connections.
     int idx = 0;
     for(java.util.Enumeration enum = _publishers.elements(); enum.hasMoreElements(); )
     {
       PublisherPortInstance info = (PublisherPortInstance)enum.nextElement();
         result[idx++] = info;
     }
     return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.PublisherPortInstanceListOperations#add_publisher_port_instance(org.objectweb.ccm.Containers.MetaInformation.PublisherPortInstance)
   */
  public void add_publisher_port_instance(PublisherPortInstance cpi)
  {
    String key = cpi.type_reference().name() ;//+ cpi.toString().substring(cpi.toString().lastIndexOf("@"));
    _publishers.put(key,cpi);
    
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.PublisherPortInstanceListOperations#remove_publisher_port_instance(java.lang.String)
   */
  public void remove_publisher_port_instance(String name) 
  throws InvalidName
  {
    Object result = _publishers.remove(name);
    
    if (result == null) throw new InvalidName();
  }
}
